#include "common.h"
#include "main.h"
#include "library.h"
#include "glib_dep.h"
#include "common_app.h"
#include "uart_dep.h"
#include "touch_dep.h"
#include "font_indep.h"
#include "picture_indep.h"

u32 main_menu_size, main_menu_count, map_menu_count, sub_menu_count;

void Wait_Key(void)
{
	u32 temp = 0;

	while(!UART_GetStatus())
	{
		if(!Get_Touch_Status() && temp == 1) break;
		temp = Get_Touch_Status();
	}
}

u32 Response_Key(void)
{
	return (Get_Touch_Status() || UART_GetStatus());
}

// ⺻  ޴ Draw
void Draw_Main_Menu(u32 page, void* menu_tree[][3])
{
	u32 temp, count;
	u32 i;

//	GLIB_ClearFrame(WHITE, 1);

	// ⺻  .
	GLIB_PutLine(0,PJBoot64.lcd_ysize - 180, PJBoot64.lcd_xsize - 1, PJBoot64.lcd_ysize - 180, BLACK);
	GLIB_PutLine(0,PJBoot64.lcd_ysize - 130, PJBoot64.lcd_xsize - 1, PJBoot64.lcd_ysize - 130, BLACK);
	
	GLIB_PutLine(PJBoot64.lcd_xsize - 100, 0, PJBoot64.lcd_xsize - 100, PJBoot64.lcd_ysize - 1, BLACK);
	GLIB_PutLine(PJBoot64.lcd_xsize - 50, 0, PJBoot64.lcd_xsize - 50, PJBoot64.lcd_ysize - 1, BLACK);
	
	GLIB_PutString_Arrow(PJBoot64.lcd_xsize - 80, 83, BLACK, NO_BackGroundColor, 0, "PJBoot 64", 1);

	GLIB_FillRectangle(PJBoot64.lcd_xsize - 99, PJBoot64.lcd_ysize - 179, 49, 49, GRAY);

	//  ޴  .
	count = 0;
	while(1)
	{
		if((u32)menu_tree[count][0] == 0) break;
		count++;
	}
	main_menu_count = count;
	
	temp = ((PJBoot64.lcd_xsize - 100) - (count * MAIN_MENU_MAX_LENGTH)) / (count + 1);
	main_menu_size = temp;
	
	// Box ..
	GLIB_FillRectangle((temp * (page + 1)) + (page * MAIN_MENU_MAX_LENGTH) - (temp / 2), PJBoot64.lcd_ysize - 179, temp * 2, 49, GRAY);
	
	// Font 
	for(i=0;i<count;i++)
	{
		
		if(page == i) GLIB_Printf((temp * (i + 1)) + (i * MAIN_MENU_MAX_LENGTH) + ((MAIN_MENU_MAX_LENGTH - strlen((char*)menu_tree[i][2]) * 8) / 2), 320, WHITE, NO_BackGroundColor, NO_UART, 0, (char*)menu_tree[i][2]);
		else
		{
			printf("\n %3d. ", i + 100);
			GLIB_Printf((temp * (i + 1)) + (i * MAIN_MENU_MAX_LENGTH) + ((MAIN_MENU_MAX_LENGTH - strlen((char*)menu_tree[i][2]) * 8) / 2), 320, BLACK, NO_BackGroundColor, UART, 0, (char*)menu_tree[i][2]);
		}
	}
	
	printf("\n 150. PJBoot64\n");
	printf(" 151. Maker\n");
}

void Position_Menu_Draw(void* tree[][6], void* maptree[][2], u32 option)
{
	u32 size_x, size_y;
	u32 i, map;
	u32 temp;
	BMP_ptr bmp;
	
	// Main Menu Draw
	i = 0;
	while(1)
	{
		if((int)tree[i][0] == 0) break;
		
		if(PJBoot64.lcd_en)
		{
			
			BMP_DrawGRAY((u32)tree[i][2], (u32)tree[i][3], (u8*)tree[i][4]);
			bmp = (BMP_ptr)tree[i][4];
			size_x = (bmp->BMP_Width_Pixels1);
			size_x |= (bmp->BMP_Width_Pixels2) << 16;
			size_y = (bmp->BMP_Height_Pixels1);
			size_y |= (bmp->BMP_Height_Pixels2) << 16;
		}

		printf("\n %3d. ", i+1);
		temp = (size_x / 2) - ((strlen((u8*)tree[i][1]) * FONT_XSIZE) / 2);
		GLIB_Printf((u32)tree[i][2] + temp, (u32)tree[i][3] + size_y + 5, BLACK, NO_BackGroundColor, UART, 0, (u8*)tree[i][1]);
		i++;
	}
	sub_menu_count = i;

	if(option)
	{
		size_x = (PJBoot64.lcd_xsize - 48) / 2;
		printf("\n  10. ");
		GLIB_Printf(size_x, PJBoot64.lcd_ysize - 30, BLACK, NO_BackGroundColor, UART, 0, "Return");
		GLIB_PutRectangle(size_x - 50, PJBoot64.lcd_ysize - 50, 148, 49, BLACK);
	}

	// Nand Map  ̱..
	if(maptree == NULL) 
	{
		map_menu_count = 0;
		return;
	}
	map = 0;
	while(1)
	{
		if((int)maptree[map][0] == 0) break;
		map++;
	}
	map_menu_count = map;
	
	// Nand Flash ޸    .
	if(map == 0) return;
	
	// Nand Map Draw
	GLIB_FillRectangle(MAP_BAR_START_X, MAP_BAR_START_Y, MAP_BAR_SIZE_X, MAP_BAR_SIZE_Y, WHITE);
	GLIB_PutRectangle(MAP_BAR_START_X, MAP_BAR_START_Y, MAP_BAR_SIZE_X, MAP_BAR_SIZE_Y, BLACK);
	GLIB_PutString(MAP_BAR_START_X + 50, MAP_BAR_START_Y - 20, RED, NO_BackGroundColor, 0, "NAND Flash Map");
	
	// Draw Map
	temp = MAP_BAR_SIZE_Y / map;
	
	for(i=0;i<map;i++)
	{
		printf("\n %3d. ", i + 10);
		GLIB_PutLine(MAP_BAR_START_X, MAP_BAR_START_Y + (temp * i), MAP_BAR_SIZE_X + MAP_BAR_START_X - 1, MAP_BAR_START_Y + (temp * i), BLACK);
		GLIB_Printf(MAP_BAR_START_X + (MAP_BAR_SIZE_X - strlen((char*)maptree[i][1]) * FONT_XSIZE) / 2, MAP_BAR_START_Y + (temp * i) + (temp / 2) - 7, BLACK, NO_BackGroundColor, UART, 0, (char*)maptree[i][1]);
	}
}

u32 Position_Check(u32 page, void* tree[][6], void* maptree[][2], void *menu_tree[][3], LCD_WINDOW eWin)
{
	int x, y, pre_x, pre_y, cal_x, cal_y;
	u32 i, drag_icon, select_icon, preselect_icon;
	u32 size_x, size_y;
	u32 touch_first;
	u32 key, total_key = 0;
	
	BMP_ptr bmp;
	
	drag_icon = 0;
	select_icon = 0;
	touch_first = 0;
	
	Switch_GLIBControl(eWin);
	printf("\nSelect the function to : ");
	
	while(1)
	{
		// Uart Է ó
		key = UART_GetStatus();
		if(key) {
			if(key >= '0' && key <= '9') {
				if(total_key == 0 && key == '0') continue;
				total_key = (total_key * 10) + key - '0';
				printf("%c", key);
			} else if(key == 8 && total_key) {
			
				total_key /= 10;
				printf("\b \b");
			} else if(key == 13) {
				
				if( (total_key > 0 && total_key <= sub_menu_count) || 
					(map_menu_count && (total_key > 9 ) && (total_key < 10 + map_menu_count)) ||
					(main_menu_count && (total_key > 99 ) && (total_key < 100 + main_menu_count) && (total_key - 100) != page) ||
					(total_key == 150) ||(total_key == 151))
				{
					select_icon = total_key;
					preselect_icon = select_icon;
					touch_first = 1;
				}
				else
				{
					while(total_key) {
						printf("\b \b");
						total_key = total_key / 10;
					}
				}
			}
		}
		
		// Touch  .
		if(Get_Touch_XY(&x, &y))
		{
			preselect_icon = select_icon;
			select_icon = 0;
			
			// ó Ŭ ġ  üũ.
			i = 0;
			while(drag_icon == 0 && touch_first == 0)
			{
				if(tree[i][0] == 0) break;
				
				if((u32)tree[i][5] == ICON_MOVE && x > (u32)tree[i][2] && y > (u32)tree[i][3])
				{
					bmp = (BMP_ptr)tree[i][4];
					size_x = (bmp->BMP_Width_Pixels1);
					size_x |= (bmp->BMP_Width_Pixels2) << 16;
					size_y = (bmp->BMP_Height_Pixels1);
					size_y |= (bmp->BMP_Height_Pixels2) << 16;

					// Icon ġ ϰ, ó  
					if(x < ((u32)tree[i][2] + size_x) && y < ((u32)tree[i][3] + size_y))
					{
						BMP_Draw((u32)tree[i][2], (u32)tree[i][3], (u8*)tree[i][4]);
						pre_x = x;
						pre_y = y;
						cal_x = x - (u32)tree[i][2];
						cal_y = y - (u32)tree[i][3];
						drag_icon = i + 1;
						break;
					}
				}
				
				i++;
			}
			
			// 巡  ̹ ó.
			if(drag_icon)
			{
				// Drawing Icon
				Switch_GLIBControl(WIN2);
				
				//  ġ ׸  ,  ..
				if(pre_x < x)
				{
					if(pre_y < y)
					{
						GLIB_FillRectangle(pre_x - cal_x, pre_y - cal_y, size_x, y - pre_y, NO_MASKING_COLOR);
						GLIB_FillRectangle(pre_x - cal_x, y - cal_y, x - pre_x, size_y + pre_y - y + 1, NO_MASKING_COLOR);
						if((y + size_y - cal_y) >= PJBoot64.lcd_ysize) cal_y = y + size_y - PJBoot64.lcd_ysize;
					}
					else
					{
						GLIB_FillRectangle(pre_x - cal_x, pre_y - cal_y, x - pre_x, size_y - pre_y + y, NO_MASKING_COLOR);
						GLIB_FillRectangle(pre_x - cal_x, size_y + y - cal_y, size_x, pre_y - y + 1, NO_MASKING_COLOR);
						if((y - cal_y) < 0) cal_y = y;
					}
					if((x + size_x - cal_x) >= PJBoot64.lcd_xsize) cal_x = x + size_x - PJBoot64.lcd_xsize;
				}
				else
				{
					if(pre_y < y)
					{
						GLIB_FillRectangle(pre_x - cal_x, pre_y - cal_y, size_x, y - pre_y, NO_MASKING_COLOR);
						GLIB_FillRectangle(x + size_x - cal_x, y - cal_y, pre_x - x, size_y + pre_y - y + 1, NO_MASKING_COLOR);
						if((y + size_y - cal_y) >= PJBoot64.lcd_ysize) cal_y = y + size_y - PJBoot64.lcd_ysize;
					}
					else
					{
						GLIB_FillRectangle(x + size_x - cal_x, pre_y - cal_y, pre_x - x, size_y + y - pre_y, NO_MASKING_COLOR);
						GLIB_FillRectangle(pre_x - cal_x, y + size_y - cal_y, size_x, pre_y - y + 1, NO_MASKING_COLOR);
						if((y - cal_y) < 0) cal_y = y;
					}
					if((x - cal_x) < 0) cal_x = x;
				}

				BMP_Draw(x - cal_x, y - cal_y, (u8*)tree[drag_icon - 1][4]);
				Switch_GLIBControl(eWin);
				
				// 巡  NAND Map ߴ  ...
				select_icon = Map_Check(x, y, maptree);
				if(select_icon) select_icon += 9;
				
				if(preselect_icon != select_icon)
				{
					if(select_icon)		MapMenu_Draw(select_icon, 1, maptree);
					if(preselect_icon)	MapMenu_Draw(preselect_icon, 0, maptree);
				}
				
				pre_x = x;
				pre_y = y;
				
				Delay(100000);
			}
			
			// 巡 尡 ƴ  Over ó.
			else
			{
				// Main ޴ ˻߿  ʴ ̹ ˻
				i = 0;
				while(1)
				{
					if((u32)tree[i][0] == 0) break;
					
					if(x > (u32)tree[i][2] && y > (u32)tree[i][3])
					{
						bmp = (BMP_ptr)tree[i][4];
						size_x = (bmp->BMP_Width_Pixels1);
						size_x |= (bmp->BMP_Width_Pixels2) << 16;
						size_y = (bmp->BMP_Height_Pixels1);
						size_y |= (bmp->BMP_Height_Pixels2) <<16;

						if(x < ((u32)tree[i][2] + size_x) && y < ((u32)tree[i][3] + size_y))
						{
							select_icon = i + 1;
							break;
						}
					}
					i++;
				}
				
				// Main ޴ ˻
				if(y > (PJBoot64.lcd_ysize - 180) && y < (PJBoot64.lcd_ysize - 130) && x > (main_menu_size / 2) && x < (PJBoot64.lcd_xsize - 120 - (main_menu_size / 2)))
				{
					select_icon = 100 + ((x - (main_menu_size / 2)) / (main_menu_size * 2));
					if(page == select_icon - 100) select_icon = 0;
				}
				
				// PJBoot64 Maker ġ ˻.
				if(x > (PJBoot64.lcd_xsize - 100) && x < (PJBoot64.lcd_xsize - 50))
				{
					if(y < PJBoot64.lcd_ysize - 180) select_icon = 150;
					else if(y > PJBoot64.lcd_ysize - 130) select_icon = 151;
				}

				// Map ޴ ˻
				i = Map_Check(x, y, maptree);
				if(i) select_icon = 9 + i;
				
				// Over ̹ ó..
				if(preselect_icon != select_icon)
				{
					if(select_icon)
					{
						if(select_icon < 10)		BMP_Draw((u32)tree[select_icon - 1][2], (u32)tree[select_icon - 1][3], (u8*)tree[select_icon - 1][4]);
						else if(select_icon < 100)	MapMenu_Draw(select_icon, 1, maptree);
						else if(select_icon < 150)	
						{
							Main_Menu_Box_Draw(select_icon - 100, 1, menu_tree);
							if(preselect_icon < 100 || preselect_icon > 150) Main_Menu_Box_Draw(page, 0, menu_tree);
						}
						else						PJBoot_Menu_Box_Draw(select_icon - 150, 1);
					}
					if(preselect_icon)
					{
						if(preselect_icon < 10)			BMP_DrawGRAY((u32)tree[preselect_icon - 1][2], (u32)tree[preselect_icon - 1][3], (u8*)tree[preselect_icon - 1][4]);
						else if(preselect_icon < 100)	MapMenu_Draw(preselect_icon, 0, maptree);
						else if(preselect_icon < 150)
						{
							Main_Menu_Box_Draw(preselect_icon - 100, 0, menu_tree);
							if(select_icon < 100 || select_icon > 150) Main_Menu_Box_Draw(page, 1, menu_tree);
						}
						else							PJBoot_Menu_Box_Draw(preselect_icon - 150, 0);
					}
				}
			}

			touch_first = 1;
		}
		
		// Touch  ...
		else
		{
			// 1 Check ϵ ó..
			if(touch_first)		
			{
				// 巡   ǥ ã...
				if(drag_icon)
				{
					Switch_GLIBControl(WIN2);
					GLIB_FillRectangle(x - cal_x, y - cal_y, size_x, size_y + 1, NO_MASKING_COLOR);
					Switch_GLIBControl(eWin);
					BMP_DrawGRAY((u32)tree[drag_icon - 1][2], (u32)tree[drag_icon - 1][3], (u8*)tree[drag_icon - 1][4]);
					
					// 巡 ¿ MemoryMap ý ó..
					if(select_icon)
					{
						printf("\n");
						return ((select_icon - 9) << 4) + drag_icon;
					}
					
					//  ġ  ġ  ó...
					if(x > ((u32)tree[drag_icon - 1][2]) && x < ((u32)tree[drag_icon - 1][2] + size_x) && y > ((u32)tree[drag_icon - 1][3]) && y < ((u32)tree[drag_icon - 1][3] + size_y))
					{
						while(total_key) {
							printf("\b \b");
							total_key = total_key / 10;
						}
						return drag_icon;
					}
				}
				
				// Drag 尡 ƴ ..
				else
				{
					// ⼺ Check
					switch(Read_Touch_arrow())
					{
						case POSITION_UP:
							return 150;
						case POSITION_DOWN:
							return 151;
						case POSITION_LEFT:
							if(page > 0) return 100 + page - 1;
							else
							{
								if(select_icon)
								{
									if(select_icon < 10)			BMP_DrawGRAY((u32)tree[select_icon - 1][2], (u32)tree[select_icon - 1][3], (u8*)tree[select_icon - 1][4]);
									else if(select_icon < 100)	MapMenu_Draw(select_icon, 0, maptree);
									else if(select_icon < 150)
									{
										Main_Menu_Box_Draw(select_icon - 100, 0, menu_tree);
										Main_Menu_Box_Draw(page, 1, menu_tree);
									}
									else							PJBoot_Menu_Box_Draw(page, 0);
								}
							}
							break;
						case POSITION_RIGHT:
							if(page < (main_menu_count - 1))	return 100 + page + 1;
							else
							{
								if(select_icon)
								{
									if(select_icon < 10)			BMP_DrawGRAY((u32)tree[select_icon - 1][2], (u32)tree[select_icon - 1][3], (u8*)tree[select_icon - 1][4]);
									else if(select_icon < 100)	MapMenu_Draw(select_icon, 0, maptree);
									else if(select_icon < 150)
									{
										Main_Menu_Box_Draw(select_icon - 100, 0, menu_tree);
										Main_Menu_Box_Draw(page, 1, menu_tree);
									}
									else							PJBoot_Menu_Box_Draw(page, 0);
								}
							}
							break;
						default:
							// Ŭ  ġ ..
							if(select_icon)
							{
								if(select_icon)
								{
									while(total_key) {
							
										printf("\b \b");
										total_key = total_key / 10;
									}
							
									printf("%d\n", select_icon);
									return select_icon;
								}
							}
							break;
					}
				}

				touch_first = 0;
				drag_icon = 0;
				select_icon = 0;
			}
		}
	}
}

u32 Simple_Select_Check(void* tree[][6])
{
	
	int x, y, pre_x, pre_y, cal_x, cal_y;
	u32 i, drag_icon, select_icon, preselect_icon;
	u32 size_x, size_y;
	u32 touch_first;
	u32 arrow;
	u32 total_key = 0, key;
	
	BMP_ptr bmp;
	
	drag_icon = 0;
	select_icon = 0;
	touch_first = 0;
	
	Switch_GLIBControl(WIN1);
	printf("\nSelect the function to : ");
	
	while(1)
	{
		// Uart Է ó
		key = UART_GetStatus();
		if(key) {
			if(key >= '0' && key <= '9') {
				if(total_key == 0 && key == '0') continue;
				total_key = (total_key * 10) + key - '0';
				printf("%c", key);
			} else if(key == 8 && total_key) {
			
				total_key /= 10;
				printf("\b \b");
			} else if(key == 13) {
				
				if(total_key)
				{
					select_icon = total_key;
					preselect_icon = select_icon;
					touch_first = 1;
				}
			}
		}

		// Touch  .
		if(Get_Touch_XY(&x, &y))
		{
			preselect_icon = select_icon;
			select_icon = 0;
			
			// Main ޴ ˻
			i = 0;
			while(1)
			{
				if((u32)tree[i][0] == 0) break;
				if(x > (u32)tree[i][2] && y > (u32)tree[i][3])
				{
					bmp = (BMP_ptr)tree[i][4];
					size_x = (bmp->BMP_Width_Pixels1);
					size_x |= (bmp->BMP_Width_Pixels2) << 16;
					size_y = (bmp->BMP_Height_Pixels1);
					size_y |= (bmp->BMP_Height_Pixels2) <<16;

					if(x < ((u32)tree[i][2] + size_x) && y < ((u32)tree[i][3] + size_y))
					{
						select_icon = i + 1;
						break;
					}
				}
				i++;
			}
			
			// Select Return
			size_x = (PJBoot64.lcd_xsize - 48) / 2;
			if(x > size_x - 50 && x < size_x + 148 && y > PJBoot64.lcd_ysize - 50)
			{
				select_icon = 10;
			}
			
			// Over ̹ ó..
			if(preselect_icon != select_icon)
			{
				if(select_icon)
				{
					if(select_icon == 10)
					{
						GLIB_FillRectangle(size_x - 50, PJBoot64.lcd_ysize - 50, 148, 49, BLACK);
						GLIB_PutString(size_x, PJBoot64.lcd_ysize - 30, WHITE, NO_BackGroundColor, 0, "Return");
					}
					else BMP_Draw((u32)tree[select_icon - 1][2], (u32)tree[select_icon - 1][3], (u8*)tree[select_icon - 1][4]);
				}
					
				if(preselect_icon)
				{
					if(preselect_icon == 10)
					{
						GLIB_FillRectangle(size_x - 50, PJBoot64.lcd_ysize - 50, 148, 49, WHITE);
						GLIB_PutRectangle(size_x - 50, PJBoot64.lcd_ysize - 50, 148, 49, BLACK);
						GLIB_PutString(size_x, PJBoot64.lcd_ysize - 30, BLACK, NO_BackGroundColor, 0, "Return");
						
					}
					else BMP_DrawGRAY((u32)tree[preselect_icon - 1][2], (u32)tree[preselect_icon - 1][3], (u8*)tree[preselect_icon - 1][4]);
				}
			}

			touch_first = 1;
		}
		
		// Touch  ...
		else
		{
			// 1 Check ϵ ó..
			if(touch_first)
			{
				// ⼺ Check
				switch(Read_Touch_arrow())
				{
					case POSITION_UP:
						break;
					case POSITION_LEFT:
						break;
					case POSITION_RIGHT:
						break;
					case POSITION_DOWN:
						select_icon = 10;
					default:
						// Ŭ  ġ ..
						if(select_icon)
						{
							while(total_key) {
					
								printf("\b \b");
								total_key = total_key / 10;
							}
					
							printf("%d\n", select_icon);
							return select_icon;
						}
						
						break;
				}

				touch_first = 0;
				drag_icon = 0;
				select_icon = 0;
			}
		}
	}
}

// ̹  м..
u32 Image_Analyser(u32 page, u32 filesize, u32 address)
{
	u32 *addr = (u32*)address;
	u32 i;
	u16 *addr16;
	u8  *addr8;

	switch(page)
	{
		case 1:		// Linux
			if((*(addr + 0) == 0xe321f0d3) || (*(addr + 0) == 0xe1a00000 && *(addr + 1) == 0xe1a00000))
			{
				Linux_Status_Update(1<<0);			// Kernel
				MemoPad_Update("Linux Kernel Type Image Found!\n");
				memcpy(PJBoot64.ram.LinuxKernel, address, filesize);
				return 1;
			}
			else
			{
				MemoPad_Update("Unknown Type Image Found!\n");
				if(!Select_View_Menu("Android Root Image ?","Yes", "No"))
				{
					Linux_Status_Update(1<<2);		// Android
					MemoPad_Update("Image Type Select : Android !\n");
					return 2;
				}
				else								// Unknown
				{
					MemoPad_Update("Image Type Select : Unknown!\n");
					return 0;
				}
			}
		case 2:		// WinCE
			MemoPad_Update("Unknown Type Image Found!\n");
			if(!Select_View_Menu("Image Type","Kernel", "Eboot"))		// Wince Kernel
			{
				Wince_Status_Update(1<<0);
				memcpy(PJBoot64.ram.WinceKernel, address, filesize);
				MemoPad_Update("Image Type Select : Wince Kernel !\n");
				return 2;
			}
			else														// Wince Eboot
			{
				Wince_Status_Update(1<<2);
				memcpy(PJBoot64.ram.Eboot, address, filesize);
				MemoPad_Update("Image Type Select : Wince Eboot !\n");
				return 1;
			}
		case 3:		// Firmware
			MemoPad_Update("Unknown Type Image Found!\n");
			if(!Select_View_Menu("Image Type","Firm", "Etc"))			// Firmware
			{
				Firmware_Status_Update(1<<0);
				memcpy(PJBoot64.ram.Firmware, address, filesize);
				MemoPad_Update("Image Type Select : Firmware !\n");
				return 1;
			}
			else														// Etc
			{
				Firmware_Status_Update(1<<2);
				memcpy(PJBoot64.ram.FirmwareTemp, address, filesize);
				MemoPad_Update("Image Type Select : Firmware Etc !\n");
				return 2;
			}
		case 9:		// PJBoot
			// Icon ̹ ˻..			
			if(filesize > (KERNEL_RECOVERY - LCD_ICON_BUFFER))
			{
				addr16 = (u16*)(address + (KERNEL_BOOT - LCD_ICON_BUFFER));

				if(*(addr16) == 0x4d42)
				{
					addr16 = (u16*)(address + (KERNEL_RECOVERY - LCD_ICON_BUFFER));
					if(*(addr16) == 0x4d42) return 2;
				}
			}

			// Bootloader ̹ ˻...
			addr8 = (u8*)address;
			for(i=0;i<filesize / 4;i++)
				if(StrCmp(addr8 + i, "D:\work\PJBoot64")) return 1;
			return 0;
	}
}

u32 Single_Run(u32 page, u32 select, void* tree[][6])
{
	u32 filesize;
	
	MemoPad_Update("Running to %s\n", (char*)(tree[select - 1][1]));

	if((u32)tree[select - 1][5] == ICON_MOVE)
	{
		if(select == 1)			filesize = Usb_Loader(PJBoot64.ram.Temp, 1);
		else if(select == 2)	filesize = Uart_Loader(PJBoot64.ram.Temp);

		//̹  Ÿ м		
		if(filesize)	Image_Analyser(page, filesize, PJBoot64.ram.Temp);
		else			MemoPad_Update("Not Load Memory!!\n");
	}
	else
	{
		if((u32)	tree[select - 1][5] != 1) ((void(*)(void))(tree[select - 1][0]))();	// Quick Run
		else		MemoPad_Update("Not Function Selected\n");
	}
	
	return filesize;
}

u32 Memory_Map_Run(u32 page, u32 select, u32 filesize, u32 option)
{
	switch(page)
	{
		case 1:	// Linux
			if(Linux_Status_Update(1<<4) && select == 10)	// Kernel Loaded
			{
//				if(option && !Select_View_Menu("Nand Process", "Read", "Write"))		// Read Process
//				{
//					filesize = Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 1);
//					if(filesize)
//					{
//						MemoPad_Update("Linux Kernel Loaded!\n");
//						Linux_Status_Update(1<<0);
//					}
//					else MemoPad_Update("Nand Read Error!\n");
//				}
//				else														// Write Process
//				{
					if(!Select_View_Menu("Nand Write from Ram ?", "Yes", "No"))
						Nand_Write_Process(0, PJBoot64.nand.Linux_Kernel, filesize, PJBoot64.ram.LinuxKernel, 1);
					else
						MemoPad_Update("Nand Write Cancle!\n");
//				}
			}
			else if(Linux_Status_Update(1<<5) && select == 11)	// Android Write
			{
				if(!Select_View_Menu("Nand Write from Ram ?", "Yes", "No"))
					Nand_NoHead_Write_Process(0, PJBoot64.nand.Android_root, filesize, PJBoot64.ram.Temp);
				else
					MemoPad_Update("Nand Write Cancle!\n");
			}
/*			else												// Nand Load Process
			{
				if(option)
				{
					if(select == 10)		// Kernel
					{
						if(!Select_View_Menu("Nand Read to Ram", "Yes", "No"))
						{
							filesize = Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 1);
							if(filesize)
							{
								MemoPad_Update("Linux Kernel Loaded!\n");
								Linux_Status_Update(1<<0);
							}
							else MemoPad_Update("Nand Read Error!\n");
						}
						else
						{
							MemoPad_Update("Nand Read Cancle!\n");
						}
					}
					else					// Android root
					{
						MemoPad_Update("Android Root Filesystem Download First!\n");
					}
				}
			}
*/			return filesize;
		case 2:	// Wince
			if(Wince_Status_Update(1<<4) && select == 10)	// Kernel Loaded
			{
//				if(option && !Select_View_Menu("Nand Process", "Read", "Write"))		// Read Process
//				{
//					filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Kernel, PJBoot64.ram.WinceKernel, 1);
//					if(filesize)
//					{
//						MemoPad_Update("Wince Kernel Loaded!\n");
//						Wince_Status_Update(1<<0);
//					}
//					else MemoPad_Update("Nand Read Error!\n");
//				}
//				else														// Write Process
//				{
					if(!Select_View_Menu("Nand Write from Ram", "Yes", "No"))
						Nand_Write_Process(0, PJBoot64.nand.Wince_Kernel, filesize, PJBoot64.ram.WinceKernel, 1);
					else
						MemoPad_Update("Nand Write Cancle!\n");
//				}
			}
			else if(Wince_Status_Update(1<<5) && select == 11)	// Eboot Loaded
			{
//				if(option && !Select_View_Menu("Nand Process", "Read", "Write"))		// Read Process
//				{
//					filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Eboot, PJBoot64.ram.Eboot, 1);
//					if(filesize)
//					{
//						MemoPad_Update("Wince Eboot Loaded!\n");
//						Wince_Status_Update(1<<2);
//					}
//					else MemoPad_Update("Nand Read Error!\n");
//				}
//				else														// Write Process
//				{
					if(!Select_View_Menu("Nand Write from Ram", "Yes", "No"))
						Nand_Write_Process(0, PJBoot64.nand.Wince_Eboot, filesize, PJBoot64.ram.Eboot, 1);
					else
						MemoPad_Update("Nand Write Cancle!\n");
//				}
			}
/*			else												// Nand Load Process
			{
				if(option)
				{
					if(select == 10)
					{
						if(!Select_View_Menu("Nand Read to Ram", "Yes", "No"))
						{
							filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Kernel, PJBoot64.ram.WinceKernel, 1);
							if(filesize)
							{
								MemoPad_Update("Wince Kernel Loaded!\n");
								Wince_Status_Update(1<<0);
							}
							else MemoPad_Update("Nand Read Error!\n");
						}
						else
						{
							MemoPad_Update("Nand Read Cancle!\n");
						}
					}
					else
					{
						if(!Select_View_Menu("Nand Read to Ram", "Yes", "No"))
						{
							filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Eboot, PJBoot64.ram.Eboot, 1);
							if(filesize)
							{
								MemoPad_Update("Wince Eboot Loaded!\n");
								Wince_Status_Update(1<<2);
							}
							else MemoPad_Update("Nand Read Error!\n");
						}
						else
						{
							MemoPad_Update("Nand Read Cancle!\n");
						}
					}
				}
			}
*/			return filesize;
		case 3:	// Firmware
			if(Firmware_Status_Update(1<<4) && select == 10)	// Kernel Loaded
			{
//				if(option && !Select_View_Menu("Nand Process", "Read", "Write"))		// Read Process
//				{
//					filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware, PJBoot64.ram.Firmware, 1);
//					if(filesize)
//					{
//						MemoPad_Update("Firmware Loaded!\n");
//						Firmware_Status_Update(1<<0);
//					}
//					else MemoPad_Update("Nand Read Error!\n");
//				}
//				else														// Write Process
//				{
					if(!Select_View_Menu("Nand Write from Ram", "Yes", "No"))
						Nand_Write_Process(0, PJBoot64.nand.Firmware, filesize, PJBoot64.ram.Firmware, 1);
					else
						MemoPad_Update("Nand Write Cancle!\n");
//				}
			}
			else if(Firmware_Status_Update(1<<5) && select == 11)	// Etc Loaded
			{
//				if(option && !Select_View_Menu("Nand Process", "Read", "Write"))		// Read Process
//				{
//					filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware_etc, PJBoot64.ram.FirmwareTemp, 1);
//					if(filesize)
//					{
//						MemoPad_Update("Firmware Etc Loaded!\n");
//						Firmware_Status_Update(1<<2);
//					}
//					else MemoPad_Update("Nand Read Error!\n");
//				}
//				else														// Write Process
//				{
					if(!Select_View_Menu("Nand Write from Ram", "Yes", "No"))
						Nand_Write_Process(0, PJBoot64.nand.Firmware_etc, filesize, PJBoot64.ram.FirmwareTemp, 1);
					else
						MemoPad_Update("Nand Write Cancle!\n");
//				}
			}
/*			else												// Nand Load Process
			{
				if(option)
				{
					if(select == 10)
					{
						if(!Select_View_Menu("Nand Read to Ram", "Yes", "No"))
						{
							filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware, PJBoot64.ram.Firmware, 1);
							if(filesize)
							{
								MemoPad_Update("Firmware Loaded!\n");
								Firmware_Status_Update(1<<0);
							}
							else MemoPad_Update("Nand Read Error!\n");
						}
						else
						{
							MemoPad_Update("Nand Read Cancle!\n");
						}
					}
					else
					{
						if(!Select_View_Menu("Nand Read to Ram", "Yes", "No"))
						{
							filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware_etc, PJBoot64.ram.FirmwareTemp, 1);
							if(filesize)
							{
								MemoPad_Update("Firmware Etc Loaded!\n");
								Firmware_Status_Update(1<<2);
							}
							else MemoPad_Update("Nand Read Error!\n");
						}
						else
						{
							MemoPad_Update("Nand Read Cancle!\n");
						}
					}
				}
			}
*/			return filesize;
	}
}

u32 Both_Run(u32 page, u32 select, void* tree[][6], void* maptree[][2])
{
	u32 filesize;
	
	MemoPad_Update("%s -> %s Write Process\n", tree[(select % 16) - 1][1], maptree[(select / 16) - 1][1]);
	if((select & 0xf) == 1)	filesize = Usb_Loader(PJBoot64.ram.Temp, 1);
	else					filesize = Uart_Loader(PJBoot64.ram.Temp);

	//̹  Ÿ м		
	if(filesize)
	{
		if(select = Image_Analyser(page, filesize, PJBoot64.ram.Temp))
		{
			Memory_Map_Run(page, select + 9, filesize, 0);
		}
		
		return filesize;
	}
	else
	{
		MemoPad_Update("Not Load Memory!!\n");
		return 0;
	}
}

void Each_Status_Check(u32 page)
{
	switch(page)
	{
		case 1:	// Linux
			if(Linux_Status_Update(1<<4))	GLIB_Printf(40, PJBoot64.lcd_ysize - 80, RED, NO_BackGroundColor, 1, 0, "Linux Kernel Loaded\n");
			if(Linux_Status_Update(1<<5))	GLIB_Printf(40, PJBoot64.lcd_ysize - 60, RED, NO_BackGroundColor, 1, 0, "Android Image Loaded\n");
			return;
		case 2:	// Wince
			if(Wince_Status_Update(1<<4))	GLIB_Printf(40, PJBoot64.lcd_ysize - 80, RED, NO_BackGroundColor, 1, 0, "Wince Kernel Loaded\n");
			if(Wince_Status_Update(1<<5))	GLIB_Printf(40, PJBoot64.lcd_ysize - 60, RED, NO_BackGroundColor, 1, 0, "Eboot Loaded\n");
			return;
		case 3:	// Firmware
			if(Firmware_Status_Update(1<<4))	GLIB_Printf(40, PJBoot64.lcd_ysize - 80, RED, NO_BackGroundColor, 1, 0, "Firmware Loaded\n");
			if(Firmware_Status_Update(1<<5))	GLIB_Printf(40, PJBoot64.lcd_ysize - 60, RED, NO_BackGroundColor, 1, 0, "Firmware Etc Loaded\n");
	}
}

u32 Map_Check(u32 x, u32 y, void* maptree[][2])
{
	u32 map, i;

	// Nand Flash ޸    
	if(map_menu_count == 0) return 0;
	map = map_menu_count;
	
	// Draw Map
	i = MAP_BAR_SIZE_Y / map;
	
	while(map--) 
	{
		//   ....
		if(x > MAP_BAR_START_X && x < MAP_BAR_SIZE_X + MAP_BAR_START_X && y > (MAP_BAR_START_Y + (i * map)) && y < (MAP_BAR_START_Y + (i * (map + 1)))) return map + 1;
	}
	
	return 0;
}

void MapMenu_Draw(u32 position, u32 option, void* maptree[][2])
{
	u32 map, i;

	// Nand Flash ޸     && x,y ǥ ġ .
	if(map_menu_count == 0) return;
	map = map_menu_count;

	// Draw Map
	i = MAP_BAR_SIZE_Y / map;
	position -= 10;

	if(option)	GLIB_FillRectangle(MAP_BAR_START_X + 1, MAP_BAR_START_Y + 1 + (i * position), MAP_BAR_SIZE_X - 2, i - 2, GREEN);
	else		GLIB_FillRectangle(MAP_BAR_START_X + 1, MAP_BAR_START_Y + 1 + (i * position), MAP_BAR_SIZE_X - 2, i - 2, WHITE);

	GLIB_PutString(MAP_BAR_START_X + (MAP_BAR_SIZE_X - strlen((char*)maptree[position][1]) * FONT_XSIZE) / 2, MAP_BAR_START_Y + (i * (position)) + (i / 2) - 7, BLACK, NO_BackGroundColor, 0, (char*)maptree[position][1]);
}

void Main_Menu_Box_Draw(u32 position, u32 option, void *menu_tree[][3])
{
	if(option)
	{
		GLIB_FillRectangle((main_menu_size * (position + 1)) + (position * MAIN_MENU_MAX_LENGTH) - (main_menu_size / 2), PJBoot64.lcd_ysize - 179, main_menu_size * 2, 49, GRAY);
		GLIB_PutString((main_menu_size * (position + 1)) + (position * MAIN_MENU_MAX_LENGTH) + ((MAIN_MENU_MAX_LENGTH - strlen((char*)menu_tree[position][2]) * 8) / 2), 320, WHITE, NO_BackGroundColor, 0, (char*)menu_tree[position][2]);
	}
	else
	{
		GLIB_FillRectangle((main_menu_size * (position + 1)) + (position * MAIN_MENU_MAX_LENGTH) - (main_menu_size / 2), PJBoot64.lcd_ysize - 179, main_menu_size * 2, 49, WHITE);
		GLIB_PutString((main_menu_size * (position + 1)) + (position * MAIN_MENU_MAX_LENGTH) + ((MAIN_MENU_MAX_LENGTH - strlen((char*)menu_tree[position][2]) * 8) / 2), 320, BLACK, NO_BackGroundColor, 0, (char*)menu_tree[position][2]);
	}
}

void PJBoot_Menu_Box_Draw(u32 position, u32 option)
{
	if(position == 0)
	{
		if(option)
		{
			GLIB_FillRectangle(PJBoot64.lcd_xsize - 99, 0, 49, PJBoot64.lcd_ysize - 180, GRAY);
			GLIB_PutString_Arrow(PJBoot64.lcd_xsize - 80, 83, WHITE, NO_BackGroundColor, 0, "PJBoot 64", 1);
		}
		else
		{
			GLIB_FillRectangle(PJBoot64.lcd_xsize - 99, 0, 49, PJBoot64.lcd_ysize - 180, WHITE);
			GLIB_PutString_Arrow(PJBoot64.lcd_xsize - 80, 83, BLACK, NO_BackGroundColor, 0, "PJBoot 64", 1);
		}
	}
	else
	{
		if(option)
		{
			GLIB_FillRectangle(PJBoot64.lcd_xsize - 99, PJBoot64.lcd_ysize - 129, 49, 129, GRAY);
			GLIB_PutString_Arrow(PJBoot64.lcd_xsize - 80, PJBoot64.lcd_ysize - 104, WHITE, NO_BackGroundColor, 0, "Maker", 1);
		}
		else
		{
			GLIB_FillRectangle(PJBoot64.lcd_xsize - 99, PJBoot64.lcd_ysize - 129, 49, 129, WHITE);
		}
	}
}

void Draw_Title_Box(char *string)
{
	u32 size;
	
	size = (PJBoot64.lcd_xsize - (strlen(string) * 8)) / 2;
	GLIB_PutString(size, 15, BLACK, NO_BackGroundColor, 0, string);
	GLIB_PutRectangle(size - 10, 5, (strlen(string) * 8) + 20, 31, BLACK);
}

// ڿ ..
int StrCmp(char *src, char *dst)
{
	while(*src != '\0') {
	
		if(*src != *dst) return 0;
		src++, dst++;
	}

	return 1;
}

//  Ŀ ܺ ޼ ˻...
char *find_Kernel_Cmd(int forward)		// Search : 0x12000
{

	char *kernel_cmd = (char *)PJBoot64.ram.LinuxKernel + 0x12000;
	char compare[] = "console=ttyS";

	// Kernel Message Search...
	while(kernel_cmd != (char *)PJBoot64.ram.LinuxRamdisk) {
	
		if(StrCmp(compare, kernel_cmd)) break;
		kernel_cmd++;
	}

	if (forward) {	// Forward Null Pointer Search...
		while(*kernel_cmd-- != '\0');
		kernel_cmd += 2;
	} else {		// Backward Null Pointer Search...
		while(*kernel_cmd++ != '\0');
		kernel_cmd--;
	}

	return kernel_cmd;
}

//   ˻.
u32 Version_Search(void)
{
	char Kernel_name[] = "Linux version 2.6.";
	char *kernel_cmd = (char *)PJBoot64.ram.LinuxKernel;

	// Kernel Message Search...
	while(kernel_cmd != (char *)PJBoot64.ram.LinuxRamdisk) {
	
		if(StrCmp(Kernel_name, kernel_cmd)) {
		
			// Linux   ̵...
			kernel_cmd += 18;
			break;
		}
		kernel_cmd++;
	}
	
	if(*kernel_cmd == '1')	return 0;		// 2.6.1x
	else					return 1;		// 2.6.2x
}

//  Ŀ ޼   ó (quite )
void Kernel_Message_Copy(char *Src, char *Dst, u32 option)
{

	u32 i;
	char *temp = " quiet";
	char *temp1 = temp;

	*Dst++ = ' ';

	// Kernel Message Change...
	while(*Src != '\0') *Dst++ = *Src++;

	// Option Message Copy...	
	if(option == 1) {
		
		while(*temp1 != '\0') *Dst++ = *temp1++;
	}
	
	// Garbage Charactor Del...
	for(i=0;i<10;i++) *Dst++ = 0x0;
}

void Uart_Logo_View(char *string, u32 id)
{
	printf("\n+-----------------------------------------------------+\n");
	printf("|  PJBoot64 %-6s (%s)                       |\n", VERSION, REL_DATE);
	printf("+-----------------------------------------------------+\n");
	if(id)	printf("|  %-20s (0x%4x)                      |\n", string, id);
	else	printf("|  %-20s                               |\n", string);
	printf("+-----------------------------------------------------+\n");
}
