#include "common.h"
#include "main.h"
#include "firmware_app.h"
#include "lcd_dep.h"
#include "glib_dep.h"
#include "picture_indep.h"
#include "common_app.h"

u32 Firmware_loaded = 0, Firmware_Etc_loaded = 0;

static void *firmware_main_function[][6] =
{
//	Function				Icon Name				Pos. X		Pos. Y		BMP Icon				Move up
	(void*)1,				(char*)"USB Down",		(u32*)100,	(u32*)50,	(u8*)BMP_USB_down,		(void*)ICON_MOVE,
	(void*)1,				(char*)"SERIAL Down",	(u32*)100,	(u32*)175,	(u8*)BMP_UART_down,		(void*)ICON_MOVE,
	(void*)Go_Firmware,		(char*)"Boot",			(u32*)500,	(u32*)375,	(u8*)KERNEL_BOOT,		(void*)ICON_NOMOVE,
	0, 0, 0, 0, 0, 0
};

static void *firmware_map_function[][2] =
{
	// Function		Name				
	(void*)2,		(char*)"ETC Area",
	(void*)2,		(char*)"Firmware Area",
	0, 0
};

void Quick_Firmware_Boot(void)
{
	//Լ ͷ ɽ
	void (*firmware)(void) = (void (*)(void))PJBoot64.ram.Firmware;
	
	if(Nand_Read_Process(0, PJBoot64.nand.Firmware, PJBoot64.ram.Firmware, 0) == 0)
	{
		MemoPad_Update("Firmware Load Failed!\n");
		return;
	}
	
	if(Nand_Read_Process(0, PJBoot64.nand.Firmware_etc, PJBoot64.ram.FirmwareTemp, 0) == 0)
	{
		MemoPad_Update("Firmware ETC Not Found!\n");
	}
	
	LCD_Stop();
	
	firmware();
	printf("\nFirmware failed...\n\n"); 		//  Ŀ Ͽ  ڴ µ ʴ´.
}

void Go_Firmware(void)
{
	u32 filesize;
	
	//Լ ͷ ɽ
	void (*firmware)(void) = (void (*)(void))PJBoot64.ram.Firmware;
	
	if(Firmware_loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware, PJBoot64.ram.Firmware, 1);
		if(filesize) MemoPad_Update("Firmware Load Success!\n");
		else
		{
			MemoPad_Update("Firmware Load Failed!\n");
			return;
		}
	}
	
	if(Firmware_Etc_loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Firmware_etc, PJBoot64.ram.FirmwareTemp, 1);
		if(filesize) MemoPad_Update("Firmware ETC Load Success!\n");
		else		 MemoPad_Update("Firmware ETC Not Found!\n");
	}
	
	MemoPad_Update("\nStarting Firmware...\n\n");
	
	LCD_Stop();
	
	firmware();
	printf("\nFirmware failed...\n\n"); 		//  Ŀ Ͽ  ڴ µ ʴ´.
}

void* Firmware_Map_Menu(void)
{
	return firmware_map_function;
}

void* Draw_Firmware_Win0(void)
{
	Firmware_Status_Update(1<<1);
	Firmware_Status_Update(1<<3);
	Uart_Logo_View("Firmware Menu Tree", 0);
	Switch_GLIBControl(WIN0);
	GLIB_ClearFrame(WHITE, 1);
	Position_Menu_Draw(firmware_main_function, firmware_map_function, 0);
	return firmware_main_function;
}

u32 Firmware_Status_Update(u32 data)
{
	switch(data)
	{
		case 1<<0:	Firmware_loaded = 1;		break;
		case 1<<1:	Firmware_loaded = 0;		break;
		case 1<<2:	Firmware_Etc_loaded = 1;	break;
		case 1<<3:	Firmware_Etc_loaded = 0;	break;
		case 1<<4:	return Firmware_loaded;
		case 1<<5:	return Firmware_Etc_loaded;
	}
}
