#include "common.h"
#include "main.h"
#include "linux_app.h"
#include "lcd_dep.h"
#include "glib_dep.h"
#include "linux_app.h"
#include "picture_indep.h"
#include "common_app.h"
#include "sysc.h"

u32 Linux_Kernel_Loaded = 0, Android_Root_loaded = 0;

static void *linux_main_function[][6] =
{
//	Function				Icon Name				Pos. X		Pos. Y		BMP Icon				Move up
	(void*)1,				(char*)"USB Down",		(u32*)100,	(u32*)50,	(u8*)BMP_USB_down,		(void*)ICON_MOVE,
	(void*)1,				(char*)"SERIAL Down",	(u32*)100,	(u32*)175,	(u8*)BMP_UART_down,		(void*)ICON_MOVE,
	(void*)Android_Boot,	(char*)"Android Boot",	(u32*)100,	(u32*)375,	(u8*)KERNEL_BOOT,		(void*)ICON_NOMOVE,
	(void*)Linux_Boot,		(char*)"Linux Boot",	(u32*)300,	(u32*)375,	(u8*)KERNEL_BOOT,		(void*)ICON_NOMOVE,
	(void*)Recovery_Linux,	(char*)"Ramdisk Boot",	(u32*)500,	(u32*)375,	(u8*)KERNEL_RECOVERY,	(void*)ICON_NOMOVE,
	0, 0, 0, 0, 0, 0
};

static void *linux_map_function[][2] =
{
	// Function		Name				
	(void*)2,		(char*)"Kernel Area",
	(void*)2,		(char*)"Android Area",
	0, 0
};

// ٿ  ̹ ˻.. (Bootloader and Icon)
static u32 Image_Analysis(u32 address, u32 size)
{
	u32 *addr = (u32*)address;
	
	// Kernel ̹ ˻..
	if((*(addr + 0) == 0xe321f0d3) || (*(addr + 0) == 0xe1a00000 && *(addr + 1) == 0xe1a00000)) return 1;
	
	return 0;
}

void Quick_Linux_Boot(void)
{
	//Լ ͷ ɽ
	void (*theKernel)(int zero, int arch) = (void (*)(int, int))PJBoot64.ram.LinuxKernel;
	
	if(Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 0) == 0)
	{
		MemoPad_Update("Kernel Load Failed!\n");
		return;
	}
	
	LCD_Stop();
	
	SYSC_ChangeMode(eASYNC_MODE);
	SYSC_ChangeSYSCLK_1(eAPLL667M, eAPLL266M, 0, 0, 3);
	
	theKernel((int)0, ARCH_NUMBER); 			// start kernel
	printf("\nKernel failed...\n\n"); 			//  Ŀ Ͽ  ڴ µ ʴ´.
}

void Recovery_Linux(void)
{
	u32 filesize;
	char *kernel_cmd;
	char kernel_cmd2[100];

	if(Linux_Kernel_Loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 1);
		if(filesize && Image_Analysis(PJBoot64.ram.LinuxKernel, filesize)) MemoPad_Update("Kernel Load Success!\n");
		else
		{
			MemoPad_Update("Kernel Load Failed!\n");
			return;
		}
		
		Linux_Status_Update(1<<0);
	}

	// Ŀθ޼  պκ ãƳ...
	kernel_cmd = (char *)find_Kernel_Cmd(1);
	MemoPad_Update("\nKernel Option : %s\n", kernel_cmd);

	//  Ŀ ޼ kernel_cmd2 ü
	sprintf(kernel_cmd2, "root=/dev/ram0 rw ramdisk=16384 initrd=0x50800000,16M mem=128M console=tty%s1,115200" ,Version_Search()?"SAC":"S");
	Kernel_Message_Copy(kernel_cmd2, kernel_cmd, MASSAGE_NO_QUIET);
	MemoPad_Update("\nChange Kernel Option : %s\n", kernel_cmd);

	filesize = Usb_Loader(PJBoot64.ram.LinuxRamdisk, 1);
	if(filesize == 0)
	{
		MemoPad_Update("\nRamdisk Download Failed\n");
		return;
	}

	Linux_Booting();
}

void Linux_Boot(void)
{
	u32 filesize;
	char *kernel_cmd;
	char kernel_cmd2[100];
	
	if(Linux_Kernel_Loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 1);
		if(filesize && Image_Analysis(PJBoot64.ram.LinuxKernel, filesize)) MemoPad_Update("Kernel Load Success!\n");
		else
		{
			MemoPad_Update("Kernel Load Failed!\n");
			return;
		}
	}
	
	// Ŀθ޼  պκ ãƳ...
	kernel_cmd = (char *)find_Kernel_Cmd(1);
	MemoPad_Update("\nKernel Option : %s\n", kernel_cmd);

	//  Ŀ ޼ kernel_cmd2 ü
	sprintf(kernel_cmd2, "root=/dev/mtdblock3 rw rootfstype=yaffs2 mem=128M console=tty%s1,115200" ,Version_Search()?"SAC":"S");
	Kernel_Message_Copy(kernel_cmd2, kernel_cmd, MASSAGE_NO_QUIET);
	MemoPad_Update("\nChange Kernel Option : %s\n", kernel_cmd);
	
	Linux_Booting();
}

void Android_Boot(void)
{
	u32 filesize;
	char *kernel_cmd;
	char kernel_cmd2[100];
	
	if(Linux_Kernel_Loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Linux_Kernel, PJBoot64.ram.LinuxKernel, 1);
		if(filesize && Image_Analysis(PJBoot64.ram.LinuxKernel, filesize)) MemoPad_Update("Kernel Load Success!\n");
		else
		{
			MemoPad_Update("Kernel Load Failed!\n");
			return;
		}
	}
	
	// Ŀθ޼  պκ ãƳ...
	kernel_cmd = (char *)find_Kernel_Cmd(1);
	MemoPad_Update("\nKernel Option : %s\n", kernel_cmd);

	//  Ŀ ޼ kernel_cmd2 ü
	sprintf(kernel_cmd2, "root=/dev/mtdblock2 rw init=/init rootfstype=jffs2 mem=128M console=tty%s1,115200" ,Version_Search()?"SAC":"S");
	Kernel_Message_Copy(kernel_cmd2, kernel_cmd, MASSAGE_NO_QUIET);
	MemoPad_Update("\nChange Kernel Option : %s\n", kernel_cmd);

	Linux_Booting();
}

void Linux_Booting(void)
{
	void (*theKernel)(int zero, int arch) = (void (*)(int, int))PJBoot64.ram.LinuxKernel; 	//Լ ͷ ɽ
	
	LCD_Stop();
	
	SYSC_ChangeMode(eASYNC_MODE);
	SYSC_ChangeSYSCLK_1(eAPLL667M, eAPLL266M, 0, 0, 3);
	
	theKernel((int)0, ARCH_NUMBER); 			// start kernel
	printf("\nKernel failed...\n\n"); 			//  Ŀ Ͽ  ڴ µ ʴ´.	
}

void* Draw_Linux_Win0(void)
{
	Linux_Status_Update(1<<1);
	Linux_Status_Update(1<<3);
	Uart_Logo_View("Linux Menu Tree", 0);
	Switch_GLIBControl(WIN0);
	GLIB_ClearFrame(WHITE, 1);
	Position_Menu_Draw(linux_main_function, linux_map_function, 0);
	return linux_main_function;
}

void* Linux_Map_Menu(void)
{
	return linux_map_function;
}

u32 Linux_Status_Update(u32 data)
{
	switch(data)
	{
		case 1<<0:	Linux_Kernel_Loaded = 1;	break;
		case 1<<1:	Linux_Kernel_Loaded = 0;	break;
		case 1<<2:	Android_Root_loaded = 1;	break;
		case 1<<3:	Android_Root_loaded = 0;	break;
		case 1<<4:	return Linux_Kernel_Loaded;
		case 1<<5:	return Android_Root_loaded;
	}
	
	return 0;
}
