#include "common.h"
#include "main.h"
#include "wince_app.h"
#include "lcd_dep.h"
#include "glib_dep.h"
#include "picture_indep.h"

u32 wince_kernel_loaded = 0, wince_eboot_loaded = 0;

static void *wince_main_function[][6] =
{
//	Function			Icon Name				Pos. X		Pos. Y		BMP Icon			Move up
	(void*)1,			(char*)"USB Down",		(u32*)100,	(u32*)50,	(u8*)BMP_USB_down,	(void*)ICON_MOVE,
	(void*)1,			(char*)"SERIAL Down",	(u32*)100,	(u32*)175,	(u8*)BMP_UART_down,	(void*)ICON_MOVE,
	(void*)Go_Wince,	(char*)"Boot",			(u32*)500,	(u32*)375,	(u8*)KERNEL_BOOT,	(void*)ICON_NOMOVE,
	0, 0, 0, 0, 0, 0
};

static void *wince_map_function[][2] =
{
	// Function		Name				
	(void*)2,		(char*)"EBOOT Area",
	(void*)2,		(char*)"KERNEL Area",
	0, 0
};

void Quick_Wince_Boot(void)
{
	//Լ ͷ ɽ
	void (*theEboot)(void) = (void (*)(void))PJBoot64.ram.Eboot;
	
	if(Nand_Read_Process(0, PJBoot64.nand.Wince_Eboot, PJBoot64.ram.Eboot, 0) == 0)
	{
		MemoPad_Update("Eboot Load Failed!\n");
		return;
	}
	
	if(Nand_Read_Process(0, PJBoot64.nand.Wince_Kernel, PJBoot64.ram.WinceKernel, 0) == 0)
	{
		MemoPad_Update("Kernel Load Failed!\n");
		return;
	}
	
	LCD_Stop();
	
	theEboot();
	printf("\nKernel failed...\n\n"); 		//  Ŀ Ͽ  ڴ µ ʴ´.
}

void Go_Wince(void)
{
	u32 filesize;
	
	//Լ ͷ ɽ
	void (*theEboot)(void) = (void (*)(void))PJBoot64.ram.Eboot;
	
	if(wince_eboot_loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Eboot, PJBoot64.ram.Eboot, 1);
		if(filesize) MemoPad_Update("Eboot Load Success!\n");
		else
		{
			MemoPad_Update("Eboot Load Failed!\n");
			return;
		}
	}
	
	if(wince_kernel_loaded == 0)
	{
		filesize = Nand_Read_Process(0, PJBoot64.nand.Wince_Kernel, PJBoot64.ram.WinceKernel, 1);
		if(filesize) MemoPad_Update("Kernel Load Success!\n");
		else
		{
			MemoPad_Update("Kernel Load Failed!\n");
			return;
		}
	}
	
	MemoPad_Update("\nStarting Wince...\n\n");
	
	LCD_Stop();
	
	theEboot();
	printf("\nKernel failed...\n\n"); 		//  Ŀ Ͽ  ڴ µ ʴ´.
}

void* Draw_Wince_Win0(void)
{
	Wince_Status_Update(1<<1);
	Wince_Status_Update(1<<3);
	Uart_Logo_View("Wince Menu Tree", 0);
	Switch_GLIBControl(WIN0);
	GLIB_ClearFrame(WHITE, 1);
	Position_Menu_Draw(wince_main_function, wince_map_function, 0);
	return (void*)wince_main_function;
}

void* Wince_Map_Menu(void)
{
	return wince_map_function;
}

u32 Wince_Status_Update(u32 data)
{
	switch(data)
	{
		case 1<<0:	wince_kernel_loaded = 1;	break;
		case 1<<1:	wince_kernel_loaded = 0;	break;
		case 1<<2:	wince_eboot_loaded = 1;	break;
		case 1<<3:	wince_eboot_loaded = 0;	break;
		case 1<<4:	return wince_kernel_loaded;
		case 1<<5:	return wince_eboot_loaded;
	}
}
