/**************************************************************************************
* 
*	Project Name : S3C6410 Validation
*
*	Copyright 2006 by Samsung Electronics, Inc.
*	All rights reserved.
*
*	Project Description :
*		This software is only for validating functions of the S3C6410.
*		Anybody can use this software without our permission.
*  
*--------------------------------------------------------------------------------------
* 
*	File Name : library.h
*  
*	File Description : This file defines the register access function
*						and declares prototypes of library funcions
*
*	Author : Haksoo,Kim
*	Dept. : AP Development Team
*	Created Date : 2006/11/08
*	Version : 0.1 
* 
*	History
*	- Created(Haksoo,Kim 2006/11/08)
*	- Added Pause() by OnPil, Shin on 2008/03/04
*  
**************************************************************************************/
#ifndef __LIBRARY_H__
#define __LIBRARY_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "common.h"
#include "system.h"
#include "watchdogtimer.h"

#define Assert(a) {if (!(a)) {printf("\n %s(line %d)\n", __FILE__, __LINE__); while(1);}}

void Delay(u32 uTime);
void GetSysClk(void);
#ifdef __cplusplus
}
#endif

#endif /*__LIBRARY_H__*/

