/*************************************************************************************
 
	Project Name : S3C6410 Validation

	Copyright 2006 by Samsung Electronics, Inc.
	All rights reserved.

	Project Description :
		This software is only for validating functions of the S3C6410.
		Anybody can use this software without our permission.
  
--------------------------------------------------------------------------------------
 
	File Name : retarget_.s
  
	File Description : This file implements the stack & heap initilaization

	Author	: Haksoo,Kim
	Dept. : AP Development Team
	Created Date : 2006/11/08
	Version : 0.1 
 
	History
	- Created(Haksoo,Kim 2006/11/08)
  
*************************************************************************************/

#include "option.inc"

.equ Mode_USR,	0x10
.equ Mode_FIQ,	0x11
.equ Mode_IRQ,	0x12
.equ Mode_SVC,	0x13
.equ Mode_ABT,	0x17
.equ Mode_UND,	0x1b
.equ Mode_SYS,	0x1f

.equ I_Bit,	0x80
.equ F_Bit,	0x40

.equ Size_FIQ_Stack,	256
.equ Size_IRQ_Stack,	256
.equ Size_ABT_Stack,	256
.equ Size_UND_Stack,	256
.equ Size_SVC_Stack,	8192


.equ Offset_FIQ_Stack,	0
.equ Offset_IRQ_Stack,	Offset_FIQ_Stack + Size_FIQ_Stack
.equ Offset_ABT_Stack,	Offset_IRQ_Stack + Size_IRQ_Stack
.equ Offset_UND_Stack,	Offset_ABT_Stack + Size_ABT_Stack
.equ Offset_SVC_Stack,	Offset_UND_Stack + Size_UND_Stack

_TEXT_BASE:
	.word	TEXT_BASE 

.globl	__user_initial_stackheap
__user_initial_stackheap:

				ldr		r0,=top_of_stacks

				msr		CPSR_c,#Mode_FIQ|I_Bit|F_Bit
				sub		sp,r0,#Offset_FIQ_Stack

				msr		CPSR_c,#Mode_IRQ|I_Bit|F_Bit
				sub     sp,r0,#Offset_IRQ_Stack

				msr		CPSR_c,#Mode_ABT|I_Bit|F_Bit
				sub		sp,r0,#Offset_ABT_Stack

				msr		CPSR_c,#Mode_UND|I_Bit|F_Bit
				sub		sp,r0,#Offset_UND_Stack

				msr		CPSR_c,#Mode_SVC|I_Bit|F_Bit
				sub		sp,r0,#Offset_SVC_Stack
				
				@IMPORT  |Image$$ZI$$Limit|
				@LDR		r0, =|Image$$ZI$$Limit|					
				ldr		r0, =base_of_heap

				mov		r2,#0
				mov		r3,#0

				mov		pc,lr
