/*************************************************************************************
 
	Project Name : S3C6410 Validation

	Copyright 2006 by Samsung Electronics, Inc.
	All rights reserved.

	Project Description :
		This software is only for validating functions of the S3C6410.
		Anybody can use this software without our permission.
  
--------------------------------------------------------------------------------------
 
	File Name : startup.s
  
	File Description : This file implements the startup procedure.

	Author	: Heemyung.Noh
	Dept. : AP Development Team
	Created Date : 2008/02/20
	Version : 0.1 
 
	History
	- Created for Scatterloading&TCM option(Heemyung.Noh 2008/02/20)
  
*************************************************************************************/
#include "option.inc"

/*=======================================================
						ENTRY  
=======================================================*/
.globl _start
_start: b	reset
				nop
				nop
				nop
				nop
				nop
				nop
				nop
				
	.balignl 16,0xdeadbeef
					
_TEXT_BASE:
		.word		TEXT_BASE

.globl _bss_start
_bss_start:
	.word __bss_start

.globl _bss_end
_bss_end:
	.word _end
	
reset:
				LDR R13, =top_of_stacks

				LDR	R0, =_initheap
				MOV	LR, PC
				BX	R0

clear_bss:
				ldr	r0, _bss_start		/* find start of bss segment        */
				ldr	r1, _bss_end		/* stop here                        */
				mov 	r2, #0x00000000		/* clear                            */

clbss_l:
				str	r2, [r0]		/* clear loop...                    */
				add	r0, r0, #4
				cmp	r0, r1
				ble	clbss_l
					
				/*;; initialise the C library (which calls main())	*/
				LDR	R0, =main
				BX   	R0
				
			   	b		.
			   	
_initheap:
		.word __user_initial_stackheap