/**************************************************************************************
* 
*	Project Name : S3C6410 Validation
*
*	Copyright 2006 by Samsung Electronics, Inc.
*	All rights reserved.
*
*	Project Description :
*		This software is only for validating functions of the S3C6410.
*		Anybody can use this software without our permission.
*  
*--------------------------------------------------------------------------------------
* 
*	File Name : system.h
*  
*	File Description : This file declares prototypes of system funcions.
*
*	Author : Haksoo,Kim
*	Dept. : AP Development Team
*	Created Date : 2006/11/08
*	Version : 0.1 
* 
*	History
*	- Created(Haksoo,Kim 2006/11/08)
*  
**************************************************************************************/

#ifndef __SYSTEM_H__
#define __SYSTEM_H__

#ifdef __cplusplus
extern "C" {
#endif

void SYSTEM_EnableVIC( void);
void SYSTEM_DisableVIC( void);
void SYSTEM_EnableIRQ( void);
void SYSTEM_DisableIRQ( void);
void SYSTEM_EnableFIQ( void);
void SYSTEM_DisableFIQ( void);

void SYSTEM_InitException( void);
void MMU_WaitForInterrupt(void);
void Stop_WFI_Test(void);
void Stop_WFI_Test1(void);

void SYSTEM_EnableBP(void);
void SYSTEM_EnableICache( void);
void SYSTEM_DisableICache( void);
void SYSTEM_EnableDCache( void);
void SYSTEM_DisableDCache( void);
void SYSTEM_InvalidateEntireICache( void);
void SYSTEM_InvalidateEntireDCache( void);
void SYSTEM_InvalidateBothCache( void);
void SYSTEM_CleanEntireDCache( void);
void SYSTEM_CleanInvalidateEntireDCache( void);
void SYSTEM_EnableMMU( void);
void SYSTEM_DisableMMU( void);
void SYSTEM_InvalidateTLB( void);
void SYSTEM_SetTTBase( u32);
void SYSTEM_SetDomain( u32);
void SYSTEM_SetFCSEPID( u32);
void SYSTEM_EnableAlignFault( void);
void SYSTEM_DisableAlignFault( void);
u32 SYSTEM_ReadDFSR( void);
u32 SYSTEM_ReadIFSR( void);
u32 SYSTEM_ReadFAR( void);

void SYSTEM_InitMmu(void);

void MEMCOPY_TEST(void);
void MEMCOPY_TEST0(void);
void MEMCOPY8 (u32 , u32, u32 );
void MEMWRITE4 (u32 , u32, u32 , u32); // addr, size, data1, data2

void UNALIGNED_Mode_EN(void);
void UNALIGNED_Mode_DIS(void);
u32 UNALIGNED_Mode_STA(void);
#ifdef __cplusplus
}
#endif

#endif /*__SYSTEM_H__*/
