/*************************************************************************************
 
	Project Name : S3C6410 Validation

	Copyright 2006 by Samsung Electronics, Inc.
	All rights reserved.

	Project Description :
		This software is only for validating functions of the S3C6410.
		Anybody can use this software without our permission.
  
--------------------------------------------------------------------------------------
 
	File Name : system_.s
  
	File Description : This file implements CP15 control.

	Author	: Haksoo,Kim
	Dept. : AP Development Team
	Created Date : 2006/11/08
	Version : 0.1 
 
	History
	- Created(Haksoo,Kim 2006/11/08)
  
*************************************************************************************/


_TEXT_BASE:
		.word	TEXT_BASE	
/*===============================================================================
*
*	Exception
*/
		.globl SYSTEM_EnableVIC
SYSTEM_EnableVIC:
						mrc 	p15,0,r0,c1,c0,0
						orr 	r0,r0,#(1<<24)
						mcr 	p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_DisableVIC
SYSTEM_DisableVIC:
						mrc 	p15,0,r0,c1,c0,0
						bic 	r0,r0,#(1<<24)
						mcr 	p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_EnableIRQ
SYSTEM_EnableIRQ:
						mrs		r0,cpsr
						bic		r0,r0,#(1<<7)
						msr		cpsr_cxsf,r0             
						mov		pc,lr

		.globl SYSTEM_DisableIRQ				
SYSTEM_DisableIRQ:
						mrs		r0,cpsr
						orr		r0,r0,#(1<<7)
						msr		cpsr_cxsf,r0             
						mov		pc,lr

		.globl SYSTEM_EnableFIQ
SYSTEM_EnableFIQ:
						mrs		r0,cpsr
						bic		r0,r0,#(1<<6)
						msr		cpsr_cxsf,r0
						mov		pc,lr

		.globl SYSTEM_DisableFIQ
SYSTEM_DisableFIQ:
						mrs		r0,cpsr
						orr		r0,r0,#(1<<6)
						msr		cpsr_cxsf,r0             
						mov		pc,lr

/*===============================================================================*/
		.globl Stop_WFI_Test
Stop_WFI_Test:
					 stmfd	sp!, {r0-r6}

					 ldr r5, =0x7E00FA1C		/* Inform7 */
					 ldr r6, [r5]		 
					 mov r0, #0
					 ldr r1, =0x7E00F90C
					 
					 mov r3, #0
					 mov r4, #0

					 
LOOP_STOP:					 
					 add r3, r3, #1
					 cmp r3, #0x2
					 blt Wait_BLK_PWR1
					 
					 
					 mcr p15,0,r0,c7,c10,5 	/* Data Memory Barrier	*/
					 mcr p15,0,r0,c7,c10,4  /* test, Data Sync. Barrier */
					 
					 mcr p15,0,r0,c7,c0,4
   					   					 
   					 
Wait_BLK_PWR1:
   					 ldr r2, [r1]
   					 cmp r2, r6
   					 bne Wait_BLK_PWR1
   					 
   					 add r4, r4, #1
   					 cmp r4, #2
   					 blt LOOP_STOP
   								
   					 ldmfd sp!, {r0-r6}
   					 					 
   					 mov pc,lr

		.globl Stop_WFI_Test1
Stop_WFI_Test1:
					 stmfd	sp!, {r0-r6}

					 ldr r5, =0x7E00FA1C		/* Inform7	*/
					 ldr r6, [r5]		 
					 mov r0, #0
					 ldr r1, =0x7E00F90C
					 
					 mov r3, #0
					 mov r4, #0
					 
LOOP_STOP1:					 
					 add r3, r3, #1
					 cmp r3, #0x2
					 blt Wait_BLK_PWR2
					 
					 ldr r1, =0x7E00F800
					 mov r0, #0x2
					 str r0, [r1]
					 
					 nop
					 nop
					 nop
					 nop
					 nop
					 nop
					 nop
					 nop
					 nop
					 nop
					 b .  					 
   					 
Wait_BLK_PWR2:
   					 nop;
   					 nop;
   					 nop;
   					 nop;
   					 nop;
   					 nop;
   					 nop; 					 
   					 add r4, r4, #1
   					 cmp r4, #2
   					 blt LOOP_STOP1
   								
   					 ldmfd sp!, {r0-r6}
   					 					 
   					 mov pc,lr

		.globl MMU_WaitForInterrupt
MMU_WaitForInterrupt:
					 mov r0, #0
					 
					 mcr p15,0,r0,c7,c10,5	 	/* Data Memory Barrier		*/
					 mcr p15,0,r0,c7,c10,4 		/* test, Data Sync. Barrier 	*/
					 mcr p15,0,r0,c7,c0,4
   					 
  					 mov pc,lr
 
/*===============================================================================
*
*			MMU/Cache
*/
					 
		.globl SYSTEM_EnableBP
SYSTEM_EnableBP:
						mrc		p15,0,r0,c1,c0,0
						orr		r0,r0,#(1<<11)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr
				
		.globl SYSTEM_EnableICache
SYSTEM_EnableICache:
						mrc		p15,0,r0,c1,c0,0
						orr		r0,r0,#(1<<12)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_DisableICache
SYSTEM_DisableICache:
						mrc		p15,0,r0,c1,c0,0
						bic		r0,r0,#(1<<12)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_EnableDCache
SYSTEM_EnableDCache:
						mrc		p15,0,r0,c1,c0,0
						orr		r0,r0,#(1<<2)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_DisableDCache
SYSTEM_DisableDCache:
						mrc		p15,0,r0,c1,c0,0
						bic		r0,r0,#(1<<2)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_InvalidateEntireICache
SYSTEM_InvalidateEntireICache:
						mov		r0,#0
						mcr		p15,0,r0,c7,c5,0
						mov		pc,lr

		.globl SYSTEM_InvalidateEntireDCache
SYSTEM_InvalidateEntireDCache:
						mov		r0,#0
						mcr		p15,0,r0,c7,c6,0
						mov		pc,lr

				
		.globl SYSTEM_InvalidateBothCache
SYSTEM_InvalidateBothCache:
						mov		r0,#0
						mcr		p15,0,r0,c7,c7,0
						mov		pc,lr

		.globl SYSTEM_CleanEntireDCache
SYSTEM_CleanEntireDCache:
						mov		r0,#0
						mcr		p15,0,r0,c7,c10,0
						mov		pc,lr
				
		.globl SYSTEM_CleanInvalidateEntireDCache
SYSTEM_CleanInvalidateEntireDCache:
						mov		r0,#0
						mcr		p15,0,r0,c7,c14,0
						mov		pc,lr

		.globl SYSTEM_EnableMMU
SYSTEM_EnableMMU:
						mrc		p15,0,r0,c1,c0,0
						orr		r0,r0,#(1<<0)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_DisableMMU
SYSTEM_DisableMMU:
						mrc		p15,0,r0,c1,c0,0
						bic		r0,r0,#(1<<0)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_InvalidateTLB
SYSTEM_InvalidateTLB:
						mov		r0,#0x0     
						mcr		p15,0,r0,c8,c7,0
						mov		pc,lr

		.globl SYSTEM_SetTTBase
SYSTEM_SetTTBase:
						mcr		p15,0,r0,c2,c0,0
						mov		pc,lr

		.globl SYSTEM_SetDomain
SYSTEM_SetDomain:
						mcr		p15,0,r0,c3,c0,0
						mov		pc,lr

		.globl SYSTEM_SetFCSEPID
SYSTEM_SetFCSEPID:
						mcr		p15,0,r0,c13,c0,0
						mov		pc,lr

		.globl SYSTEM_EnableAlignFault
SYSTEM_EnableAlignFault:
						mrc		p15,0,r0,c1,c0,0
						orr		r0,r0,#(1<<1)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_DisableAlignFault
SYSTEM_DisableAlignFault:
						mrc		p15,0,r0,c1,c0,0
						bic		r0,r0,#(1<<1)
						mcr		p15,0,r0,c1,c0,0
						mov		pc,lr

		.globl SYSTEM_ReadDFSR
SYSTEM_ReadDFSR:
						mrc		p15,0,r0,c5,c0,0
						mov		pc,lr

		.globl SYSTEM_ReadIFSR
SYSTEM_ReadIFSR:
						mrc		p15,0,r0,c5,c0,1
						mov		pc,lr

		.globl SYSTEM_ReadFAR
SYSTEM_ReadFAR:
						mrc		p15,0,r0,c6,c0,0
						mov		pc,lr

		.globl EBI_Test_Assem
EBI_Test_Assem:
						ldr	r1, =0x70200010	/* Dest Addr of NFCON	*/
						ldr	r2, =0x55555555
						ldr	r3, =0xaaaaaaaa
						ldr	r4, =0xffffffff
						ldr	r5, =0x5a5a5a5a

						ldr	r8, =0x00005555	/* DATA	*/
						ldr	r9, =0x70200010	/* NFCON DATA Register	*/
						
						ldr	r6, =0x0000aaaa	/* DATA	*/
						ldr	r7, =0x7030192C	/* CFCON Register	*/

						/*---------- WW --------------
						* Store to NFCON Data register
						*/
						str	r8,[r9]			/* DATA -> NFCON Data Register	*/
						/* Store to CFCON Register	*/
						str	r6, [r7]			/* DATA -> CFCON Data Register	*/

						nop
						nop

						/*---------- WR --------------						
						* Store to NFCON Data register
						*/
						str	r8,[r9]			/* DATA -> NFCON Data Register	*/
						/* Read from CFCON Register	*/
						ldr	r0, [r7]			/* CFCON Data Register -> Register	*/

						nop
						nop

						/*---------- BWW --------------*/
						stm	r1,{r2-r5}			/* DATA -> NFCON Data Register	*/
						/* Store to CFCON Register	*/
						str	r6, [r7]			/* DATA -> CFCON Data Register	*/

						nop
						nop

						/*---------- BWR --------------*/
						stm	r1,{r2-r5}			/* DATA -> NFCON Data Register	*/
						/* Read from CFCON Register	*/
						ldr	r0, [r7]			/* CFCON Data Register -> Register	*/

						nop
						nop

		.globl Set_Ata_Cmd_START
Set_Ata_Cmd_START:
						ldr		r8, = 0x0
						ldr		r9, =0x1				/* START command	*/
						ldr		r10, =0x70301908		/* ATA_COMMAND register	*/
						swp		r8, r9, [r10]			/* swap operation	*/
						mov		pc,lr

		.globl Set_Ata_Cmd_STOP
Set_Ata_Cmd_STOP:		/*	PROC	*/
						ldr		r8, = 0x0
						ldr		r9, =0x0				/* STOP command	*/
						ldr		r10, =0x70301908		/* ATA_COMMAND register	*/
						swp		r8, r9, [r10]			/* swap operation	*/
						mov		pc,lr

		.globl Set_Ata_Cmd_ABORT
Set_Ata_Cmd_ABORT:
						ldr		r8, = 0x0
						ldr		r9, =0x2				/* ABORT command	*/
						ldr		r10, =0x70301908		/* ATA_COMMAND register	*/
						swp		r8, r9, [r10]			/* swap operation	*/
						mov		pc,lr

		.globl Set_Ata_Cmd_CONTINUE
Set_Ata_Cmd_CONTINUE:
						ldr		r8, = 0x0
						ldr		r9, =0x3				/* CONTINUE command	*/
						ldr		r10, =0x70301908		/* ATA_COMMAND register	*/
						swp		r8, r9, [r10]			/* swap operation	*/
						mov		pc,lr
												
		.globl MEMCOPY_TEST
MEMCOPY_TEST:
					    ldr	r0, =0x51000000
					    ldr r1, =0x52000000
					    ldr r2, =0x8000
					    ldr r3, =0
TCOPY:					    
					    ldmia r0!, {r5-r12}
					    stmia r1!,  {r5-r12}		
					    add r3, r3, #1
					    cmp r3, r2
					    blt	TCOPY
						mov		pc,lr
						
		.globl MEMCOPY_TEST0
MEMCOPY_TEST0:
					    ldr	r0, =0x41000000
					    ldr r1, =0x42000000
					    ldr r2, =0x8000
					    ldr r3, =0
TCOPY0:					    
					    ldmia r0!, {r5-r12}
					    stmia r1!,  {r5-r12}		
					    add r3, r3, #1
					    cmp r3, r2
					    blt	TCOPY0
						mov		pc,lr


		.globl MEMCOPY8
MEMCOPY8:
						stmfd	sp!, {r0-r12}
					    ldr r3, =0
TCOPY8:					    
					    ldmia r0!, {r5-r12}
					    stmia r1!,  {r5-r12}		
					    add r3, r3, #1
					    cmp r3, r2
					    blt	TCOPY8
					    ldmfd	sp!, {r0-r12}
						mov		pc,lr

		.globl MEMWRITE4
MEMWRITE4:
						stmfd	sp!, {r0-r8}
					    ldr r4, =0
TWRITE4:			    			
							    
					  	mov r5, r2
						mov r6, r3	    
						mov r7, r2
						mov r8, r3
					    
					    stmia r0!, {r5-r8}
					    add r4, r4, #1
					    cmp r4, r1
					    blt	TWRITE4
					    ldmfd	sp!, {r0-r8}
						mov		pc,lr

		.globl MODEM_BlockCopy
MODEM_BlockCopy:
				      STMDB	r13!,{r0-r2,r4-r11,lr}
					    mov		pc,lr
						
						.globl  UNALIGNED_Mode_EN
UNALIGNED_Mode_EN:
						mrc 	p15,0,r0,c1,c0,0
						orr 	r0,r0,#(1<<22)
						mcr 	p15,0,r0,c1,c0,0
						
						mov		pc, lr

						.globl  UNALIGNED_Mode_DIS
UNALIGNED_Mode_DIS:
						mrc 	p15,0,r0,c1,c0,0
						bic 	r0,r0,#(1<<22)
						mcr 	p15,0,r0,c1,c0,0
						
						mov		pc, lr

						.globl  UNALIGNED_Mode_STA
UNALIGNED_Mode_STA:
						mrc 	p15,0,r0,c1,c0,0
						mov		pc, lr
