#ifndef __TIMER_H__
#define __TIMER_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "s3c6410.h"


enum TIMER_REG
{
	rTCFG0   = ELFIN_TIMER_BASE+0x00,
	rTCFG1   = ELFIN_TIMER_BASE+0x04,
	rTCON    = ELFIN_TIMER_BASE+0x08,
	rTCNTB0  = ELFIN_TIMER_BASE+0x0C,
	rTCMPB0  = ELFIN_TIMER_BASE+0x10,
	rTCNTO0  = ELFIN_TIMER_BASE+0x14,
	rTCNTB1  = ELFIN_TIMER_BASE+0x18,
	rTCMPB1  = ELFIN_TIMER_BASE+0x1C,
	rTCNTO1  = ELFIN_TIMER_BASE+0x20,
	rTCNTB2  = ELFIN_TIMER_BASE+0x24,
	rTCMPB2  = ELFIN_TIMER_BASE+0x28,
	rTCNTO2  = ELFIN_TIMER_BASE+0x2C,
	rTCNTB3  = ELFIN_TIMER_BASE+0x30,
	rTCMPB3  = ELFIN_TIMER_BASE+0x34,
	rTCNTO3  = ELFIN_TIMER_BASE+0x38,
	rTCNTB4  = ELFIN_TIMER_BASE+0x3C,
	rTCNTO4  = ELFIN_TIMER_BASE+0x40,
	rTINT_CSTAT = ELFIN_TIMER_BASE+0x44

};


typedef enum eDelay_measure
{
	micro	= 0,
	milli	= 1,
} eDelay_M;

void PWM_UserSelect(void);
void PWM_Select(u32 uTimer, u32 uPrescaler, u32 uDivider, u32 uTCNTB, u32 uTCMPB, u32 uEnDz, u32 uDzlen, u32 uEnDMA, u32 uAutoreload, u32 uEnInverter,u32 uEnInt);
void PWM_stopAll(void);
void PWM_stop(u32 uNum);
u32 PWM_ReadrTCMPB(u32 uNum);
//void WDT_operate(u32 uEnReset, u32 uEnInt, u32 uSelectCLK, u32 uEnWDT, u32 uPrescaler,u32 uWTDAT, u32 uWTCNT);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMEROS(void);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMER0(void);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMER1(void);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMER2(void);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMER3(void);
void __attribute__ ((interrupt("IRQ"))) Isr_TIMER4(void);

void DelayfrTimer(eDelay_M cMeasure, u32 uDnum);
void StartTimer(u32 uTsel);
u32 StopTimer(u32 uTsel);
void Clear_Timer(u8 id);
u32 GetTickCount(void);

#ifdef __cplusplus
}
#endif


#endif //__TIMER_H__
