//#include <stdarg.h>
//#include <string.h>
//#include <stdio.h>
//#include "def.h"
#include "common.h"
#include "lcd_dev.h"
#include "library.h"

#include "glib_dep.h"
#include "font_indep.h"

#define CC24_16(c)	         ( ((((c)>>19)&0x1f)<<11)|((((c)>>10)&0x3f)<< 5)|((((c)>>3)&0x1f)<<0) )

GLIB oGlib;

void GLIB_PutPixel(u32 x, u32 y, u32 cvalue)
{
	if(x >= oGlib.m_uHsz) return;
	if(y >= oGlib.m_uVsz) return;
	
	if(PJBoot64.lcd_en == 0) return;

	if (oGlib.m_uBpp == 8)								*((u8 *)(oGlib.m_pFrameBuf)+oGlib.m_uHsz*(y)+(x)) = (u8)cvalue;
	else if (oGlib.m_uBpp == 16)						*((u16 *)(oGlib.m_pFrameBuf)+oGlib.m_uHsz*(y)+(x)) = (u16)cvalue;
	else if (oGlib.m_uBpp == 18 || oGlib.m_uBpp == 24)	*((u32 *)(oGlib.m_pFrameBuf)+oGlib.m_uHsz*(y)+(x)) = cvalue;
}

// 긮 ˰
void GLIB_PutLine(u32 x1, u32 y1, u32 x2, u32 y2, u32 cvalue)
{


	int x, y, temp;
	int delta_x, delta_y, half, error = 0;

	// ׻ x2 >= x1, y2 > y1  ǵ Ѵ.
	if( x1 > x2 ){
		temp = x1;
		x1 = x2;
		x2 = temp;
	}
	if( y1 > y2 ){
		temp = y1;
		y1 = y2;
		y2 = temp;
	}

	// x, y ȭ?Ѵ.
	delta_x = x2 - x1;
	delta_y = y2 - y1;

	// ó  ´
	GLIB_PutPixel( x1, y1, cvalue );

	//  ǥ ￡   ߴ´.
	if( delta_x > delta_y )
	{
		y = y1;
		half = (int)( delta_x / 2 );

		for( x = x1+1; x <= x2; x ++ )
		{
			error += delta_y;
			if( error > half )
			{
				y ++;
				error -= delta_x;
			}
			GLIB_PutPixel( x, y, cvalue );
		}
	}
	else
	{
		x = x1;
		half = (int)( delta_y / 2 );

		for( y = y1+1; y <= y2; y ++ )
		{
			error += delta_x;
			if( error > half )
			{
				x ++;
				error -= delta_y;
			}
			GLIB_PutPixel( x, y, cvalue );
		}
	}
}

void GLIB_PutRectangle(u32 x1, u32 y1, u32 dx, u32 dy, u32 cvalue)
{
	u32 x2 = x1+dx-1;
	u32 y2 = y1+dy-1;
	
	GLIB_PutLine(x1,y1,x2,y1,cvalue);
	GLIB_PutLine(x2,y1,x2,y2,cvalue);
	GLIB_PutLine(x1,y2,x2,y2,cvalue);
	GLIB_PutLine(x1,y1,x1,y2,cvalue);
}

void GLIB_FillRectangle(int x1, int y1, u32 dx, u32 dy, u32 cvalue)
{
	u32 x2 = x1+dx;
	u32 y2 = y1+dy;
	
	if(x1 < 0) x1 = 0;
	if(y1 < 0) y1 = 0;
	
	for(dy=y1;dy<y2;dy++)
//		GLIB_PutLine(x1,dy,x2,dy,cvalue);
		for(dx=x1;dx<x2;dx++)
			GLIB_PutPixel(dx,dy,cvalue);
}

// 긮 ˰
void GLIB_PutCircle(int x0, int y0, u32 ratio, u32 color)
{
	int x, y, thres;

	if( ratio == 0 ){
		GLIB_PutPixel( x0, y0, color );
		return;
	}

	y = ratio;
	thres = 3 - (ratio + ratio);

	for( x = 0; x < y; x ++ )
	{
		if( thres < 0 ) thres += 6 + (x << 2);
		else
		{
			thres += 10 + ((x - y) << 2);
			y --;
		}

		GLIB_PutPixel( x0+x, y0+y, color ); GLIB_PutPixel( x0+y, y0+x, color );
		GLIB_PutPixel( x0-x, y0+y, color ); GLIB_PutPixel( x0-y, y0+x, color );
		GLIB_PutPixel( x0+x, y0-y, color ); GLIB_PutPixel( x0+y, y0-x, color );
		GLIB_PutPixel( x0-x, y0-y, color ); GLIB_PutPixel( x0-y, y0-x, color );
	}
}

void GLIB_FillCircle(int x, int y, u32 ratio, u32 color) 
{ 
	int a, b, P; 
	a = 0; 
	b = ratio; 
	P = 1 - ratio; 

	do
	{ 
		GLIB_PutLine(x-a, y+b, x+a, y+b, color); 
		GLIB_PutLine(x-a, y-b, x+a, y-b, color); 
		GLIB_PutLine(x-b, y+a, x+b, y+a, color); 
		GLIB_PutLine(x-b, y-a, x+b, y-a, color); 

		if(P < 0) 	P+= 3 + 2*a++; 
		else		P+= 5 + 2*(a++ - b--); 
	} while(a <= b); 
}

// 긮 ˰
void GLIB_PutEllipse(int x0, int y0, u32 a0, u32 b0, u32 color)
{
	int x = 0, y = b0;
	long a = a0, b = b0;
	long a_squ = a * a;
	long two_a_squ = a_squ << 1;
	long b_squ = b * b;
	long two_b_squ = b_squ << 1;
	long d, dx, dy;

	d = b_squ - a_squ * b + (a_squ >> 2);
	dx = 0;
	dy = two_a_squ * b;

	while( dx < dy ){
		GLIB_PutPixel( x0+x, y0+y, color );
		GLIB_PutPixel( x0-x, y0+y, color );
		GLIB_PutPixel( x0+x, y0-y, color );
		GLIB_PutPixel( x0-x, y0-y, color );
		if( d > 0 ){
			y --;
			dy -= two_a_squ;
			d -= dy;
		}
		x ++;
		dx += two_b_squ;
		d += b_squ + dx;
	}

	d += ( 3*(a_squ - b_squ)/2 - (dx+dy)/2 );

	while( y >= 0 ){
		GLIB_PutPixel( x0+x, y0+y, color );
		GLIB_PutPixel( x0-x, y0+y, color );
		GLIB_PutPixel( x0+x, y0-y, color );
		GLIB_PutPixel( x0-x, y0-y, color );
		if( d < 0 ){
			x ++;
			dx += two_b_squ;
			d += dx;
		}
		y --;
		dy -= two_a_squ;
		d += a_squ - dy;
	}
}



void GLIB_ClearFrame(u32 cvalue, u32 logo)
{
	u32 i, j;
	
	for(j=0; j<oGlib.m_uVsz; j++)
		for(i=0; i<oGlib.m_uHsz; i++)
			GLIB_PutPixel(i, j, cvalue);

	if(logo) 
	{
		GLIB_PutString( 10, 5, BLACK, NO_BackGroundColor, 0, "Mango64");
//		GLIB_Printf(oGlib.m_uHsz - 120, 5, RED, NO_BackGroundColor, NO_UART, 0, "PJBoot64 %s", VERSION);
//		GLIB_PutString(oGlib.m_uHsz - 170, oGlib.m_uVsz - 20, BLACK, NO_BackGroundColor, 0, "Release : ");
//		GLIB_PutString(oGlib.m_uHsz - 90, oGlib.m_uVsz - 20, BLACK, NO_BackGroundColor, 0, REL_DATE);
	}

}

void GLIB_Init(u32 uFbAddr, u32 uHSize, u32 uVSize, CSPACE eBpp)
{
	oGlib.m_uHsz = uHSize;
	oGlib.m_uVsz = uVSize;
	oGlib.m_uBpp =
		(eBpp == RGB8 || eBpp == ARGB8) ? 8 :
		(eBpp == RGB16 || eBpp == ARGB16) ? 16 :
		(eBpp == RGB24 || eBpp == ARGB24) ? 24 : 24;

	oGlib.m_pFrameBuf = (void*)uFbAddr;
}

void* GLIB_GetFB(void)
{
	return oGlib.m_pFrameBuf;
}

///////////////////////////////////// Font //////////////////////////////////////////
u32 GLIB_PutString_Arrow(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_y, char *string, u32 arrow)
{
	if(arrow) GLIB_PutString2(x, y, font_color, background_color, max_y, string);
	else	  GLIB_PutString(x, y, font_color, background_color, max_y, string);
}
u32 GLIB_PutString2(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_y, char *string)
{
	u32 charactor;
	u32 pre_y = y;

	while(*string)	{
	
		charactor = *string++;
		if(charactor < 0x80) {

			if(charactor == '\n') 
			{
				y = pre_y;
				x += FONT_YSIZE;
				continue;
			}
			
			if(max_y && (y + FONT_YSIZE > max_y))
			{
				y = pre_y;
				x += FONT_YSIZE;
			}
			
			GLIB_PutEngChar(charactor, background_color, font_color, x, y);
			y += FONT_YSIZE;
		} else {
			if(max_y && (y + FONT_YSIZE > max_y))
			{
				y = pre_y;
				x += FONT_YSIZE;
			}
			// ϼ  ȯ..
			charactor = (charactor << 8) | (*string & 0xFF);
			charactor = KssmToKs(charactor);
			GLIB_PutKorChar(charactor, background_color, font_color, x, y);
			string++;
			y += FONT_YSIZE;
		}
	}
	
	return y;
}

u32 GLIB_PutString(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_x, char *string)
{
	u32 charactor;
	u32 pre_x = x;

	while(*string)	{
	
		charactor = *string++;
		if(charactor < 0x80) {

			if(charactor == '\n') 
			{
				x = pre_x;
				y += FONT_YSIZE;
				continue;
			}
			
			if(max_x && (x + FONT_XSIZE > max_x))
			{
				x = pre_x;
				y += FONT_YSIZE;
			}
			
			GLIB_PutEngChar(charactor, background_color, font_color, x, y);
			x += FONT_XSIZE;
		} else {
			if(max_x && (x + FONT_YSIZE > max_x))
			{
				x = pre_x;
				y += FONT_YSIZE;
			}
			// ϼ  ȯ..
			charactor = (charactor << 8) | (*string & 0xFF);
			charactor = KssmToKs(charactor);
			GLIB_PutKorChar(charactor, background_color, font_color, x, y);
			string++;
			x += FONT_YSIZE;
		}
	}
	
	return y;
}

u32 GLIB_Printf(u32 x, u32 y, u32 font_color, u32 background_color, DEBUG_UART uart, u32 max_x, const char *fmt,...)
{
	va_list ap;
	char string[256];
	
	va_start(ap,fmt);
	vsprintf(string,fmt,ap);
	if(uart == UART) UART_Printf(string);
	y = GLIB_PutString(x, y, font_color, background_color, max_x, string);
	va_end(ap);
	
	return y;
}

