#ifndef __GLIB_DEP_H__
#define __GLIB_DEP_H__

#include "lcd_dep.h"

typedef enum 
{
	NO_UART,
	UART
} DEBUG_UART;

#define WHITE								(0xffffff)
#define BLACK								(0x0)
#define RED									(0xff0000)
#define	GREEN								(0xff00)
#define BLUE								(0xff)
#define GRAY								(0x919191)
#define WHITEGRAY							(0xa0a0a0)

/////////////////////////////////////////////////////

// fb, size, bitmap setting.
void GLIB_Init(u32 uFbAddr, u32 uHSize, u32 uVSize, CSPACE eBpp);

// use library
void GLIB_PutLine(u32 x1, u32 y1, u32 x2, u32 y2, u32 cvalue);
void GLIB_PutRectangle(u32 x1, u32 y1, u32 dx, u32 dy, u32 cvalue);
void GLIB_FillRectangle(int x1, int y1, u32 dx, u32 dy, u32 cvalue);
void GLIB_ClearFrame(u32 cvalue, u32 logo);
void GLIB_PutPixel(u32 x, u32 y, u32 cvalue);
void GLIB_PutCircle(int x0, int y0, u32 ratio, u32 color);
void GLIB_FillCircle(int x, int y, u32 ratio, u32 color);
void GLIB_PutEllipse(int x0, int y0, u32 a0, u32 b0, u32 color);

// Font using..
u32 GLIB_PutString_Arrow(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_y, char *string, u32 arrow);
u32 GLIB_PutString(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_x, char *string);
u32 GLIB_PutString2(u32 x, u32 y, u32 font_color, u32 background_color, u32 max_y, char *string);
u32 GLIB_Printf(u32 x, u32 y, u32 font_color, u32 background_color, DEBUG_UART uart, u32 max_x, const char *fmt,...);

typedef struct {
	u32  m_uHsz;
	u32  m_uVsz;
	u32  m_uBpp;
	void* m_pFrameBuf;
} GLIB;

#endif //__GLIB_H__
