#ifndef __LCD_DEP_H__
#define __LCD_DEP_H__
#ifdef __cplusplus
extern "C" {
#endif

typedef enum 
{
	WIN0, WIN1, WIN2, WIN3, WIN4
}LCD_WINDOW;

typedef enum
{
	PAL1, PAL2, PAL4, PAL8,
	RGB8, ARGB8, RGB16, ARGB16, RGB18, RGB24, RGB30, ARGB24,
	YC420, YC422, // Non-interleave
	CRYCBY, CBYCRY, YCRYCB, YCBYCR, YUV444, // Interleave
	RGBA16, RGBX24, RGBA24
} CSPACE;

void LCD_GetFrmSz(u32* uFrmHSz, u32* uFrmVSz, LCD_WINDOW eWin);
void LCD_Blend_ColorKeyOn(u8 NonKey_R, u8 NonKey_G, u8 NonKey_B, u8 Key_R, u8 Key_G, u8 Key_B, u32 Key_Color, LCD_WINDOW eWin);
void LCD_Blend_ColorKeyOff(LCD_WINDOW eWin);
void LCD_SetColorMapValue(u32 uVal, LCD_WINDOW eWin);
void LCD_Trigger(void);
void Enable_GLib_WinOnOff(LCD_WINDOW eWin, u8 OnOff);
void Switch_GLIBControl(LCD_WINDOW eWin);
void LCD_Move_Arrow_Win(u32 arrow, LCD_WINDOW eWin);
void LCD_GetFbEndAddr(u32* uFbAddr, LCD_WINDOW eWin);
u32 LCD_GetFbStartAddr(LCD_WINDOW eWin);
void LCD_InitWinRegs(LCD_WINDOW eWin);

void LCD_Init(u32 start_frame_buffer);
void LCD_Start(void);
void LCD_Stop(void);
#ifdef __cplusplus
}
#endif
#endif
