#ifndef __NAND_DEP_H__
#define __NAND_DEP_H__
#ifdef __cplusplus
extern "C" {
#endif

#define NAND_CONNUM						(1)
#define	NAND_TEMP_ADDRESS				0x53f80000

/******************************************/
/*          Variable Define               */
/******************************************/
#define ID_K9S1208V0M		(0xec76)
#define ID_KMXD64P3 		(0x9876)
#define ID_K9F2G08U0M		(0xecda)
#define ID_K9F2G16U0M		(0xecca)
#define ID_K9G8G08U0M		(0xecd3)

typedef struct NAND_Inform
{
	u32	uNandType;
	u32 uAddrCycle;
	u32 uBlockNum;
	u32 uPageNum;
	u32 uPageSize;
	u32 uSpareSize;
	u32 uTacls;
	u32 uTwrph0;
	u32 uTwrph1;
	u8 (*Init)(u32);
	u32(*ReadID)(u32);
} NAND_oInform;
extern NAND_oInform	NAND_Inform[NAND_CONNUM];

typedef enum NAND_ERROR
{
	eNAND_NoError = 0x00, 	eNAND_1bitEccError = 0x01, 	eNAND_2bitEccError = 0x02, eNAND_3bitEccError = 0x04, eNAND_4bitEccError = 0x08,
	eNAND_MultiError = 0x10, 	eNAND_EccAreaError = 0x20, 	eNAND_UncorrectableError = 0x40, 	eNAND_EtcError = 0x80, 	eNAND_Spare1bitEccError = 0x100,
	eNAND_SpareMultiError = 0x200,	eNAND_SpareEccAreaError = 0x400, eNAND_ProgramError = 0x800, eNAND_EraseError = 0x1000, 	eNAND_InvalidBlock = 0x2000,
	eNAND_IllegalAccError = 0x4000,
	eNAND_5bitEccError = 0x10000, 	eNAND_6bitEccError = 0x20000, eNAND_7bitEccError = 0x40000, eNAND_8bitEccError = 0x80000	
}NAND_eERROR;

void Board_Nand_Init(u32 id);

u32 Nand_Read_Process(u32 id, u32 start_block, u32 destAddress, u32 speed);
u32 Nand_Write_Process(u32 id, u32 start_block, u32 filesize, u32 sourAddress, u32 speed);
u32 Nand_NoHead_Write_Process(u32 id, u32 start_block, u32 filesize, u32 sourAddress);
void Nand_Format_Process(u32 id);

#ifdef __cplusplus
}
#endif
#endif //__NAND_DEP_H__
