#ifndef __TOUCH_DEV_H__
#define __TOUCH_DEV_H__
#ifdef __cplusplus
extern "C" {
#endif

#define	RESSEL12BIT				1	// A/D conversion   0: 10-bit,   1: 12-bit

#define	ENABLE					1
#define	DISABLE					0
#define	SELECT					1
#define	DESELECT				0

#define	STYLUS_DOWN				0
#define	STYLUS_UP				1

#define	ADCTS_TOUCH_INIT		2
#define	ADCTS_TOUCH_DOWN		0
#define	ADCTS_TOUCH_UP			1

#define	ADCTS_PRSCVL			10

typedef enum ADCTS_Id
{
	eADCTS_ADCCON = 0,
	eADCTS_ADCTSC = 1,
	eADCTS_ADCDLY = 2,
	eADCTS_ADCDAT0 = 3,
	eADCTS_ADCDAT1 = 4,
	eADCTS_ADCUPDN = 5,
	eADCTS_ADCCLRINT = 6,
	eADCTS_ADCCLRINTPNDNUP = 8,
}eADCTS_Id;

typedef enum ADCTS_MeasureModeId
{
	eADCTS_MEASURE_NOP = 0,
	eADCTS_MEASURE_MANUAL_X = 1,
	eADCTS_MEASURE_MANUAL_Y = 2,
	eADCTS_MEASURE_AUTO_SEQ = 3,
	eADCTS_MEASURE_FOR_STYLUS = 4,
}eADCTS_MeasureModeId;

typedef struct ADCTS_Inform
{	
	u32	uADCSampleData;	
	u8	ucADCflag;
	u8	ucTouchStatus;
}ADCTS_oInform;

extern volatile ADCTS_oInform g_oADCTSInform;
/*---------------------------------- APIs of rADCCON ---------------------------------*/
u8	ADCTS_Init(void);
void ADC_InitADCCON(void);
u8 ADC_IsEOCFlag(void);
void ADC_EnableReadStart(u8);
void ADC_EnableStart(u8);
u8 ADC_IsAfterStartup(void);
/*---------------------------------- APIs of rADCTSC ---------------------------------*/
void ADCTS_SetMeasureMode(u8 );
void ADCTS_SetStylusDetectMode(u8 );
/*---------------------------------- APIs of rADCDLY ---------------------------------*/
void ADCTS_SetDelayClkSrc(u8 );
void ADCTS_SetDelay(u32 );
/*---------------------------------- APIs of rADCDATx ---------------------------------*/
u8 ADCTS_GetXPStylusIntState(void);
u32 ADCTS_GetXPData(void);
u32 ADCTS_GetYPData(void);
/*---------------------------------- APIs of INT Clear Registers ---------------------------------*/
void ADCTS_SetADCClearInt(void);
void ADCTS_SetADCClearWKInt(void);
/*---------------------------------- APIs of general ADCTS ---------------------------------*/
u32 ADCTS_GetRegValue(u8);
void ADCTS_SetRegValue(u8, u32);

#ifdef __cplusplus
}
#endif

#endif /*__ADCTS_H__*/
