#ifndef _TIME_HEADER_
#define _TIME_HEADER_

#define TIMER_CLOCK_FREQUENCY	200000000
#define TICKS_PER_SECOND	(TIMER_CLOCK_FREQUENCY>>4)	// 200MHz prescaled by 16
#define TICKS_PER_MSCND		(TICKS_PER_SECOND/1000)	// Ticks per sec/1000
#define TICKS_PER_USCND		(TICKS_PER_MSCND/1000)		// Ticks per Msec/1000

void			TimerEnable( void );
void			TimerDisable( void );

unsigned int  	TimerGetTime(void);       		// 1/TICKS_PER_SECOND  ð  ȯѴ. 
unsigned int	TimerSetTick( unsigned int	ticks);
unsigned int	TimerWaitTick( unsigned int ticks);
unsigned int TimerWaitForSec( int secs );
unsigned int TimerWaitForMilliSec( int millisecs );

extern void 	ReloadTimer( unsigned char bTimer, unsigned int msec);
extern int  	TimeOverflow( unsigned char bTimer );
extern void 	FreeTimer( unsigned char bTimer );

void		delay(unsigned int sec);
void		mdelay(unsigned int msec);
void		udelay( unsigned int usec );
void	EnablePeriodicTimer ( void );

#endif //_TIME_HEADER_
