#include "common.h"

#include "font_indep.h"
#include "font_kor_indep.h"
#include "font_ascii_indep.h"

// ѱ Ʈ  ´° ˻ؼ fontBuffer ..
void KorFonttoBuffer(u32 charactor, u8 *fontBuffer)
{
	u32 i, charactor_temp;
	u8 chosung_5bit, joongsung_5bit, jongsung_5bit;
	u8 chosung_bul, joongsung_bul, jongsung_bul, jongsung_flag;

	jongsung_bul = 0;
	chosung_5bit = table_cho[(charactor >> 10) & 0x001F];		// ʼ: 14-10 5bit 
	joongsung_5bit = table_joong[(charactor >> 5) & 0x001F];	// ߼: 09-05 5bit 
	jongsung_5bit = table_jong[charactor & 0x001F];				// : 04-00 5bit 

	if(jongsung_5bit) {											//  

		jongsung_flag = 1;
		chosung_bul = bul_cho2[joongsung_5bit];
		if((chosung_5bit == 1) || (chosung_5bit == 16))	joongsung_bul = 2;		// 1: Fill Code, 16: 
		else									joongsung_bul = 3;
		jongsung_bul = bul_jong[joongsung_5bit];

   	} else {													//  

		jongsung_flag = 0;
		chosung_bul = bul_cho1[joongsung_5bit];
		if((chosung_5bit == 1) || (chosung_5bit == 16))	joongsung_bul = 0;		// 1: Fill Code, 16: 
		else									joongsung_bul = 1;
	}

	//----------------------- Ʈ ۷ ---------------------------
	charactor_temp = (chosung_bul * 20) + chosung_5bit;					// ʼ Ʈ  
	for(i=0;i<32;i++) fontBuffer[i] = K_font[charactor_temp][i];

	charactor_temp = (8 * 20) + (joongsung_bul * 22) + joongsung_5bit;	// ߼ Ʈ OR
	for(i=0;i<32;i++) fontBuffer[i] |= K_font[charactor_temp][i];
	    
	if(jongsung_flag) {													//  ϸ OR

		charactor_temp = (8 * 20) + (4 * 22) + (jongsung_bul * 28) + jongsung_5bit;
		for(i=0;i<32;i++) fontBuffer[i] |= K_font[charactor_temp][i];
   	}
}

// ϼ  ȯ...
u32 KssmToKs(u32 kssm)
{
	u8 high,low;
	u32 index, result;

	high = (kssm>>8) & 0xFF;
	low  =  kssm & 0xFF;

	index = (high - 0xB0) * 94 + low - 0xA1;
	result = (KSTable[index][0] << 8) + KSTable[index][1];
	return result;
}

//  ϼ ȯ...
u32 KsToKssm(u32 ks)
{
	u32 from, to, i;

	switch(ks & 0xff00) {
	
	case 0x8800: from = 0x000; to = 0x033; break;
	case 0x8900: from = 0x033; to = 0x068; break;
	case 0x8a00: from = 0x068; to = 0x091; break;
	case 0x8b00: from = 0x091; to = 0x0ab; break;
	case 0x8c00: from = 0x0ab; to = 0x0cd; break;
	case 0x8d00: from = 0x0cd; to = 0x0ed; break;
	case 0x8e00: from = 0x0ed; to = 0x10e; break;
	case 0x8f00: from = 0x10e; to = 0x123; break;
	case 0x9000: from = 0x123; to = 0x150; break;
	case 0x9100: from = 0x150; to = 0x173; break;
	case 0x9200: from = 0x173; to = 0x191; break;
	case 0x9300: from = 0x191; to = 0x1b0; break;
	case 0x9400: from = 0x1b0; to = 0x1da; break;
	case 0x9500: from = 0x1da; to = 0x1fc; break;
	case 0x9600: from = 0x1fc; to = 0x215; break;
	case 0x9700: from = 0x215; to = 0x230; break;
	case 0x9800: from = 0x230; to = 0x24f; break;
	case 0x9900: from = 0x24f; to = 0x262; break;
	case 0x9a00: from = 0x262; to = 0x272; break;
	case 0x9b00: from = 0x272; to = 0x286; break;
	case 0x9c00: from = 0x286; to = 0x2aa; break;
	case 0x9d00: from = 0x2aa; to = 0x2cb; break;
	case 0x9e00: from = 0x2cb; to = 0x2ea; break;
	case 0x9f00: from = 0x2ea; to = 0x305; break;
	case 0xa000: from = 0x305; to = 0x32d; break;
	case 0xa100: from = 0x32d; to = 0x34d; break;
	case 0xa200: from = 0x34d; to = 0x370; break;
	case 0xa300: from = 0x370; to = 0x386; break;
	case 0xa400: from = 0x386; to = 0x3ae; break;
	case 0xa500: from = 0x3ae; to = 0x3d1; break;
	case 0xa600: from = 0x3d1; to = 0x3ef; break;
	case 0xa700: from = 0x3ef; to = 0x407; break;
	case 0xa800: from = 0x407; to = 0x427; break;
	case 0xa900: from = 0x427; to = 0x437; break;
	case 0xaa00: from = 0x437; to = 0x441; break;
	case 0xab00: from = 0x441; to = 0x450; break;
	case 0xac00: from = 0x450; to = 0x483; break;
	case 0xad00: from = 0x483; to = 0x4af; break;
	case 0xae00: from = 0x4af; to = 0x4d9; break;
	case 0xaf00: from = 0x4d9; to = 0x4f3; break;
	case 0xb000: from = 0x4f3; to = 0x50f; break;
	case 0xb100: from = 0x50f; to = 0x522; break;
	case 0xb200: from = 0x522; to = 0x534; break;
	case 0xb300: from = 0x534; to = 0x549; break;
	case 0xb400: from = 0x549; to = 0x582; break;
	case 0xb500: from = 0x582; to = 0x5bd; break;
	case 0xb600: from = 0x5bd; to = 0x5ee; break;
	case 0xb700: from = 0x5ee; to = 0x619; break;
	case 0xb800: from = 0x619; to = 0x643; break;
	case 0xb900: from = 0x643; to = 0x668; break;
	case 0xba00: from = 0x668; to = 0x687; break;
	case 0xbb00: from = 0x687; to = 0x6a0; break;
	case 0xbc00: from = 0x6a0; to = 0x6c0; break;
	case 0xbd00: from = 0x6c0; to = 0x6d3; break;
	case 0xbe00: from = 0x6d3; to = 0x6e4; break;
	case 0xbf00: from = 0x6e4; to = 0x6f2; break;
	case 0xc000: from = 0x6f2; to = 0x715; break;
	case 0xc100: from = 0x715; to = 0x72f; break;
	case 0xc200: from = 0x72f; to = 0x74b; break;
	case 0xc300: from = 0x74b; to = 0x762; break;
	case 0xc400: from = 0x762; to = 0x780; break;
	case 0xc500: from = 0x780; to = 0x7a1; break;
	case 0xc600: from = 0x7a1; to = 0x7ba; break;
	case 0xc700: from = 0x7ba; to = 0x7cd; break;
	case 0xc800: from = 0x7cd; to = 0x7ec; break;
	case 0xc900: from = 0x7ec; to = 0x805; break;
	case 0xca00: from = 0x805; to = 0x81c; break;
	case 0xcb00: from = 0x81c; to = 0x837; break;
	case 0xcc00: from = 0x837; to = 0x857; break;
	case 0xcd00: from = 0x857; to = 0x874; break;
	case 0xce00: from = 0x874; to = 0x88c; break;
	case 0xcf00: from = 0x88c; to = 0x8a0; break;
	case 0xd000: from = 0x8a0; to = 0x8bd; break;
	case 0xd100: from = 0x8bd; to = 0x8e7; break;
	case 0xd200: from = 0x8e7; to = 0x90d; break;
	case 0xd300: from = 0x90d; to = 0x92d; break;
	default    : from = 0x000; to = 0x000; break;
	};
	
	for(i=from;i<to;i++) {
	
		if(KSTable[i][1] == (ks & 0xff)) return 0xb0a1 + i + ((i / 94) * 162);
	
	}
	
	return 0;

}

// ڵ ѱ ϼ ȯ...
u32 UniToKssm(u32 wchar)
{
	u32 chosung, joongsung, jongsung;
	u32 result = 0x8000;

	// ʼ 
	chosung = 2 + (wchar - 0xAC00) / (21*28);

	// ߼ 
	joongsung = (wchar - 0xAC00) % (21*28) / 28;
	if(joongsung < 5)		joongsung += 3;
	else if(joongsung < 11)	joongsung += 5;
	else if(joongsung < 17)	joongsung += 7;
	else					joongsung += 9;

	//  
	jongsung  = (wchar - 0xAC00) % 28;
	if(jongsung < 17)		jongsung++;
	else				jongsung += 2;

	// ʼ + ߼ +  =  ѱ
	result |= chosung << 10;
	result |= joongsung << 5;
	result |= jongsung;
	
	return KsToKssm(result);
}

// ڵ ѱ  ȯ
u32 UniToKs(u32 wchar)
{
	u32 chosung, joongsung, jongsung;
	u32 result = 0x8000;

	// ʼ 
	chosung = 2 + (wchar - 0xAC00) / (21*28);

	// ߼ 
	joongsung = (wchar - 0xAC00) % (21*28) / 28;
	if(joongsung < 5)		joongsung += 3;
	else if(joongsung < 11)	joongsung += 5;
	else if(joongsung < 17)	joongsung += 7;
	else					joongsung += 9;

	//  
	jongsung  = (wchar - 0xAC00) % 28;
	if(jongsung < 17)		jongsung++;
	else				jongsung += 2;

	// ʼ + ߼ +  =  ѱ
	result |= chosung << 10;
	result |= joongsung << 5;
	result |= jongsung;

	return result;
}

//  Ʈ 
void GLIB_PutEngChar(u8 charactor, u32 background_color, u32 font_color, u32 xPos, u32 yPos)
{
	u32 x, y;
	u8 up_data, down_data;

	for(x=0;x<FONT_XSIZE;x++) {
	
		up_data = E_font[charactor][x];
		down_data = E_font[charactor][x + FONT_XSIZE];
		
		for(y=0;y<FONT_YSIZE/2;y++) {

			if(up_data & 0x1) 	GLIB_PutPixel(xPos + x, yPos + y, font_color);
			else if(background_color != NO_BackGroundColor) GLIB_PutPixel(xPos + x, yPos + y, background_color);
			up_data >>= 1;
			
			if(down_data & 0x1)	GLIB_PutPixel(xPos + x, yPos + y + 8, font_color);
			else if(background_color != NO_BackGroundColor) GLIB_PutPixel(xPos + x, yPos + y + 8, background_color);
			down_data >>= 1;
		}
	}	
}

// ѱ Ʈ 
void GLIB_PutKorChar(u32 charactor, u32 background_color, u32 font_color, u32 xPos, u32 yPos)
{
	u32 x, y;
	u8 up_data, down_data;
	u8 KorfontBuffer[32] = {0};	// 32Byte ѱƮ 

	KorFonttoBuffer(charactor, KorfontBuffer);

	for(x=0;x<FONT_XSIZE*2;x++) {
	
		up_data = KorfontBuffer[x];
		down_data = KorfontBuffer[x + FONT_XSIZE*2];
		
		for(y=0;y<FONT_YSIZE/2;y++) {

			if(up_data & 0x1)	GLIB_PutPixel(xPos + x, yPos + y, font_color);		
			else if(background_color != NO_BackGroundColor) GLIB_PutPixel(xPos + x, yPos + y, background_color);
			up_data >>= 1;
			
			if(down_data & 0x1)	GLIB_PutPixel(xPos + x, yPos + y + 8, font_color);		
			else if(background_color != NO_BackGroundColor) GLIB_PutPixel(xPos + x, yPos + y + 8, background_color);
			down_data >>= 1;
		}
	}		
}