#ifndef __PICTURE_INDEP_H__
#define __PICTURE_INDEP_H__

struct __attribute__ ((packed)) BMP_head_Struct {		// Bitmap Header
	u16 BMP_Signature;			// 0 ~ 1
	u16 BMP_Size1;				// 2 ~ 
	u16	BMP_Size2;				//   ~ 5
	u16	BMP_Reserved1;			// 6 ~ 
	u16	BMP_Reserved2;			//   ~ 9
	u16	BMP_Begin1;				// 10 ~ 
	u16	BMP_Begin2;				//    ~ 13
	u16	BMP_Header_Size1;		// 14 ~ 
	u16	BMP_Header_Size2;		//    ~ 17
	u16	BMP_Width_Pixels1;		// 18 ~ 
	u16	BMP_Width_Pixels2;		//    ~ 21
	u16	BMP_Height_Pixels1;		// 22 ~ 
	u16	BMP_Height_Pixels2;		//    ~ 25
	u16	BMP_Num_Planes;			// 26 ~ 27
	u16	BMP_Num_BitPerPixels;	// 28 ~ 29
	u16	BMP_Compress_Type1;		// 30 ~ 
	u16	BMP_Compress_Type2;		//    ~ 33
	u16	BMP_Size_DataInByte1;	// 34 ~ 
	u16	BMP_Size_DataInByte2;	//    ~ 37
	u16	BMP_vertical_PPMeter1;	// 38 ~ 
	u16	BMP_vertical_PPMeter2;	//    ~ 41
	u16	BMP_Num_Color1;			// 42 ~ 
	u16	BMP_Num_Color2;			//    ~ 45
	u16	BMP_Num_Im_Color1;		// 46 ~ 
	u16	BMP_Num_Im_Color2;		//    ~ 49
};      //bmp  	
typedef struct BMP_head_Struct *		BMP_ptr;

#define LCD_ICON_BUFFER						(0x57d60000)

// Main
#define WinCE_BOOT				LCD_ICON_BUFFER + 0x00000	// 90 x 90 ( 0x5fe0 )
#define Linux_BOOT				LCD_ICON_BUFFER + 0x05fe0
#define Firmware_BOOT			LCD_ICON_BUFFER + 0x0bfc0
#define Creator_MENU			LCD_ICON_BUFFER + 0x11fa0	// 40 x 40 ( 0x1300 )

// Download Icon (USB, Uart, TFTP)
#define BMP_USB_down			LCD_ICON_BUFFER + 0x132a0	// 70 x 70 ( 0x3a40 )
#define BMP_UART_down			LCD_ICON_BUFFER + 0x16ce0
#define BMP_SD_down				LCD_ICON_BUFFER + 0x1a720

// PJ Configure
#define PJBOOT_Cfg				LCD_ICON_BUFFER + 0x1e160

// Kernel
#define KERNEL_BOOT				LCD_ICON_BUFFER + 0x21ba0
#define KERNEL_RECOVERY			LCD_ICON_BUFFER + 0x255e0

u32 Icon_Search(void);
void BMP_DrawGRAY(u32 x, u32 y, u8 *buffer);
void BMP_Draw(u32 x, u32 y, u8 *buffer);

#endif
