#include "common.h"
#include "queue_indep.h"

#define free		pjfree
#define malloc	pjmalloc

typedef struct oqueue queue_struct;
struct oqueue
{
	u32 data;
	queue_struct *node;
};

queue_struct *queue_header = NULL, *queue_point = NULL;

void queue_insert(u32 data)
{
	queue_struct *queue;
	
	queue = (queue_struct *)malloc(sizeof(queue_struct));
	
	queue->data = data;
	queue->node = NULL;
	
	if(queue_header)	queue_point->node = queue;
	else				queue_header = queue;
	
	queue_point = queue;
}

u32 queue_delete(void)
{
	u32 data;
	queue_struct *queue;
	
	if(queue_header == NULL) return 0;
	data = queue_header->data;
	
	queue = queue_header;
	
	queue_header = queue_header->node;
	
	free(queue);
	
	return data;
}

void queue_free(void)
{
	u32 i;
	queue_struct *queue;
	
	while(queue_header != NULL)
	{
		queue = queue_header;
		queue_header = queue_header->node;
		free(queue);
	}
}
