#ifndef __MAIN_H__
#define __MAIN_H__
#ifdef __cplusplus
extern "C" {
#endif

//#include "../common/def.h"
//extern void Uart_Printf(char *fmt,...);
//#define printf	Uart_Printf

#define VERSION					"V1.1.1"
#define REL_DATE				"09. 07. 10"

#define Board_Serial			0x00000ffc

#define NO_BackGroundColor		0xffffffff

#define POSITION_LEFT			2
#define POSITION_RIGHT			1
#define POSITION_UP				8
#define POSITION_DOWN			4
#define POSITION_RANDOM			16

#define ICON_MOVE				1
#define ICON_NOMOVE				0

#define NO_MASKING_COLOR		0xefffff

#define SWAP8(A)				(A)
#define SWAP16(A)				((((A)&0x00ff)<<8)|((A)>>8))
#define SWAP32(A)				((((A)&0x000000ff)<<24)|(((A)&0x0000ff00)<<8)|(((A)&0x00ff0000)>>8)|(((A)&0xff000000)>>24))

typedef struct oRAM_MAP
{
	u32 Vector_table;
	u32 Stack;
	u32 Heap;
	u32 Config;
	u32 bootload;
	u32 Image;
	u32 FrameBuffer;
	u32 LinuxKernel;
	u32 LinuxRamdisk;
	u32 WinceKernel;
	u32 Eboot;
	u32 Firmware;
	u32 FirmwareTemp;
	u32 Temp;
	
} mem_map;

typedef struct oNAND_MAP
{
	u32 Wince_Kernel;
	u32 Wince_Eboot;
	u32 Firmware;
	u32 Firmware_etc;
	u32 Linux_Filesystem;
	u32 Android_data;
	u32 Android_root;
	u32 Linux_Kernel;
	u32 Boot_Icon;
	u32 Boot_CFG;
	u32 Bootloader;
	u32 Booter;
	u32 Etc;
} nand_map;

typedef struct CONFIG_ST 
{
	u32 armclk;
	u32 hclk;
	u32 pclk;
	u32 apll;
	u32 mpll;
	u32 lcd_en;
	u32 touch_en;
	u32 uart_en;
	u32 usb_en;
	u32 mmc_en;
	u32 button_en;
	u32 lcd_xsize;
	u32 lcd_ysize;
	u32 nand_id;
	u32 nand_type;
	u32 nand_total_block;
	u32 nand_1_block;
	u32 board_id;
	mem_map ram;
	nand_map nand;
} Config;
extern Config PJBoot64;

void* Draw_Main_Win0(void);
void* Main_Map_Menu(void);
void StepLoader_Write(void);
void Hardware_Init(void);

#ifdef __cplusplus
}
#endif
#endif
